/* Layout Manager JBV 2012-2013 */



var LayoutManager = function(iInsertPoint,iStartEvent){

	this._fsmStates={};
	this._layoutMap={};
	this._insertPoint=iInsertPoint;
	this._startEvent = iStartEvent; // Check start point is a state !!!
	this._hasStarted = false;
	HashCall.pushHashFunction(LayoutManager.hashcall(this));
} 

LayoutManager.prototype.start = function(){
	
	this._hasStarted = true;
	var aState = this.resolveNextState(this._startEvent)
	this.startPoint(aState.layoutname);
	
	var aSplit = getLocationSplit();
	aSplit.ref = this._startEvent;
	var aHash = buildLocationHash(aSplit);
	TextElement.hashcall(aHash); // this is to force the links
									  				 // to be loaded after

	$.history.load(aHash);
	
}

LayoutManager.prototype.setFailsafe = function(iFunction){
	this._failSafeFunction = iFunction;
}

// Init calls for hash management

LayoutManager.hashcall = function(iManager){

	return function(iHash) {
		
		var aManager = iManager;
		//console.log("Manager to be called:"+iHash);
		//console.log(aManager);
	
		var aEvent =  getHashSplit(iHash);
		aManager.callEvent(aEvent.ref, iHash);
		
		//TextElement.hashcall(iHash); // this is to force the links
									 // to be loaded after
	
	}
	
}


LayoutManager.prototype.addLayout = function(iLayoutName,iLayout,iDialog) {

	this._layoutMap[iLayoutName] = {};
	this._layoutMap[iLayoutName].layout = iLayout;
	this._layoutMap[iLayoutName].inserted = false;
	this._layoutMap[iLayoutName].dialog = iDialog;
	
}

LayoutManager.prototype.addFSMEvent = function(iLayoutName1, iLayoutName2, iEvent, iFunction){

	var aLayoutName1 = iLayoutName1;
	if (aLayoutName1 == "*" ) {
		aLayoutName1 = "_STAR_";
	}

	if (typeof this._fsmStates[iEvent]==="undefined") {
		this._fsmStates[iEvent] ={}
		this._fsmStates[iEvent][aLayoutName1] = {};
		this._fsmStates[iEvent][aLayoutName1].layoutname = iLayoutName2;
		if (valid(iFunction)) {this._fsmStates[iEvent][aLayoutName1].callFunction = iFunction;}
	} else {
		if (typeof this._fsmStates[iEvent][aLayoutName1]==="undefined") {
			this._fsmStates[iEvent][aLayoutName1] = {};
			this._fsmStates[iEvent][aLayoutName1].layoutname = iLayoutName2;
			if (valid(iFunction)) {this._fsmStates[iEvent][aLayoutName1].callFunction = iFunction;}
		} else {
			alert("FSM Error : state already defined ("+aLayoutName1+","+iLayoutName2+","+iEvent+")");
		}
	}

}

LayoutManager.prototype.hideCurrent = function(){
	$("#"+this._start).fadeOut('slow');
}

LayoutManager.prototype.forceLayoutResize = function(){

	console.log("Force Layout Resize");
	forceResize = true;
	console.log(this._start);
	handleDependentResize($("#"+this._start),"",true);
	
}

LayoutManager.prototype.showCurrent = function(){
	$("#"+this._start).fadeIn('slow').promise().done(this.forceLayoutResize());
}

LayoutManager.prototype.startPoint = function(iLayoutName){
	
	//console.log("Start point:"+iLayoutName);
	
	var prev = this._start;
	this._start = iLayoutName;
	
	if (typeof this._layoutMap[this._start]==="undefined") {
		console.log("FSM Error : start point not defined ("+this._start+")");
		if (valid(this._failSafeFunction)) {
				this.callFailsafe();
		} 
		return;
	}
	
	if (this._layoutMap[this._start].inserted) {
		
		this.shiftLayout(this._start, true, +1000);
		
	} else {
		
		//console.log("Insert the layout in the DOM");
		this._layoutMap[this._start].inserted = true;
		
		//console.log("Insert layout in the DOM:");
		//console.log($(this._insertPoint));
		$(this._insertPoint).append("<div id='"+iLayoutName+"' style='position:absolute; top 0px; left: 0px; margin : 0px; padding: 0px; overflow : hidden; width:100%; height:100%;' ></div>");
		
		var aLayout = this._layoutMap[this._start].layout;
		aLayout.insert("#"+iLayoutName);
		
	}
	
	
	
}

LayoutManager.prototype.shiftLayout = function(iName,iShow,iValue){

	var aLayout = this._layoutMap[iName].layout;
	
	if (iShow) {
		$("#"+iName).css("visibility","visible");
		aLayout.show().shiftZIndex(iValue);
	} else {
		$("#"+iName).css("visibility","hidden");
		aLayout.hide().shiftZIndex(iValue);
	}
	
	var currentZIndex = $("#"+iName).css("z-index");
	$("#"+iName).css( 'z-index' , currentZIndex+iValue );

}

LayoutManager.prototype.pushEvent = function(iEvent){
	var aSplit = {}; //getLocationSplit(); // reset context
	aSplit.ref = iEvent;
	$.history.load(buildLocationHash(aSplit));
}

LayoutManager.prototype.callFailsafe = function() {
	this._failSafeFunction();
}

LayoutManager.prototype.resolveNextState =  function(iEvent) {

	var aEventMap = this._fsmStates[iEvent];
	if (typeof aEventMap==="undefined") {
		console.log("FSM Error : event not defined ("+iEvent+")");
		if (valid(this._failSafeFunction)) {
				this.callFailsafe();
		} 
		return;
	}
	
	var aFromState = aEventMap[this._start];
	if (typeof aFromState==="undefined") {
	
		aFromState = aEventMap["_STAR_"];
		
		if (!valid(aFromState)) {
			console.log("FSM Error : transition not defined for this event ("+this._start+","+iEvent+")");
			
			if (valid(this._failSafeFunction)) {
				this.callFailsafe();
			} 
			
			return;
		}
		
	}

	return aFromState;
}

LayoutManager.prototype.callEvent = function(iEvent,iHash){
	
	if (this._hasStarted) {
	
		var aToState = this.resolveNextState(iEvent);
	
		if (valid(aToState)) { // else failsafe has been called

			this.shiftLayout(this._start, false, -1000);
			this.startPoint(aToState.layoutname);
			
			//console.log("Force TextElement");
			if (valid(iHash)) {
				//console.log("To hash:"+iHash);
				TextElement.hashcall(iHash); // this is to force the links
										     // to be loaded after
			}
		
			if (valid(aToState.callFunction)) {
				aToState.callFunction();
			} 
		
		}
	
	} else {
	
		this._startEvent = iEvent;
	
	}
	
}
