// ######################## DEFINE Container Element ######################

var ContainerElement = function(iElement){
	Element.call(this);
	this.id = null;
	this.internalElement = iElement;
} 

ContainerElement.prototype = new Element();
ContainerElement.prototype.constructor = ContainerElement;

ContainerElement.prototype.addStyle = function (iStyle) {
	this.style = iStyle;
	return this;
}

ContainerElement.prototype.addClass = function (iClass) {
	this.addedClass = iClass;
	return this;
}

ContainerElement.prototype.getInnerElements = function () {
	return [this.internalElement];
}

ContainerElement.prototype.onClick = function (iOnClickFunction){
	this.onClickFunction = iOnClickFunction;
	return this;
}

ContainerElement.prototype.onEnterBkColor = function(iBkColor){
	this.onEnterBkColorV = iBkColor;
}

ContainerElement.prototype.implement = function () {
	this.id = elementID;
	this.element =  "#elem"+this.id;
	//this.internalElement.element = "#elem"+this.id; 
	elementID++;
	
	// Here test wrapping definition
	this.internalElement = this.checkWrapping(this.internalElement);
	
	var html_code =  "<div id='elem"+this.id+"' class='containerElement ui-widget-content ui-corner-all";
	
	if (!(typeof this.addedClass==='undefined')) {
		html_code = html_code + this.addedClass+"'";
	} else {
		html_code = html_code + "'";
	}
	
	html_code = html_code + "style='position: relative; overflow:hidden; width :100%; height : 100%;";
	
	if (!(typeof this.style==='undefined')) {
		html_code = html_code + this.style+"'>";
	} else {
		html_code = html_code + "'>";
	}
	
	html_code = html_code +this.internalElement.implement()+"</div>";
	
	return html_code;
}

ContainerElement.onMouseEnterCB = function(aElement){

	//console.log("Mouse Enter");
	var bkcolor = $(aElement).data('onEnterBkColor');
	if (valid(bkcolor)) {
		$(aElement).css("backgroundColor",bkcolor);
		$(aElement).css("backgroundImage", "none");
	}

}

ContainerElement.onMouseOutCB = function(aElement){

	//console.log("Mouse Out");
	var bkcolor = $(aElement).data('bkcolor');
	if (valid(bkcolor)) {$(aElement).css("backgroundColor",bkcolor);}

}

ContainerElement.prototype.afterInsert = function() {
	
	//console.log("after insert container");
	//console.log(this.element);
	
	var aElement = $(this.element);
	
	aElement.data('prop', this.prop);
	
	if (valid(this.attached)) {
		$(aElement).data("attached",this.attached);
	}
	
	if (valid(this.onClickFunction)) {
		console.log("On click function installed");
		aElement.click(this.onClickFunction);
		aElement.css('cursor', 'pointer');
	}
	
	aElement.data("bkcolor",aElement.css("backgroundColor"));
	if (valid(this.onEnterBkColorV)) {
	
		//console.log("add mouse listener :"+this.onMouseOverColor);
	
		aElement.data("onEnterBkColor",this.onEnterBkColorV);
		
		aElement.mouseover(function(e){
			ContainerElement.onMouseEnterCB(aElement);
		});
		aElement.mouseout(function(e){
			ContainerElement.onMouseOutCB(aElement);
		});
	
	}
	
	if (!(typeof this.internalElement === "undefined")) {
	
		var wrap = false;
		if (!(typeof this.prop==='undefined')) {
		
			if (!(typeof this.prop.wrap==='undefined')) {
				
				wrap = this.prop.wrap;
				
			}
		
		}
	
		//console.log('wrap container:'+wrap);
		$(this.internalElement.element).data('parentWrap',wrap);
	
		this.internalElement.afterInsert();		
		
	} 
	
	ContainerElement.resize(this.element);
	
}

// Static method
ContainerElement.resize = function (iContainer,iChain, iForceResize){
	
	//console.log("Container");
	//console.log(iContainer);
	var aContainer = $(iContainer);
	var prop = aContainer.data('prop');
	
	//console.log(prop);
	var wrap = false;
	var fixed = false;
	if (!(typeof prop==='undefined')) {
	
		if (!(typeof prop.wrap==='undefined')) {
			
			wrap = prop.wrap;
			
		}
		
		if (valid(prop.fixed)) {
			fixed = true;
		}
	
	}
	
	if (wrap && !fixed) { // wrap size of inner element
	
		handleDependentResize(aContainer,iChain,iForceResize); // Pre resize
		var children = aContainer.children();
		aContainer.width($(children).outerWidth(true));
		aContainer.height($(children).outerHeight(true));
		
	} else if (fixed) { // Fixed means container have fixed size
		
		aContainer.width(prop.width);
		aContainer.height(prop.height);
		handleDependentResize(aContainer,iChain,iForceResize);
		
	} else { // Default mode takes the size of parents elements
		var parent = aContainer.parent();
		
		var hBorder = aContainer.outerWidth()-aContainer.innerWidth();
		var vBorder = aContainer.outerHeight()-aContainer.innerHeight();
		
		aContainer.width(parent.innerWidth()-(hBorder+parseInt(parent.css("padding-left"))+parseInt(parent.css("padding-right")))); // TODO correct this with inner/outer config 
		aContainer.height(parent.innerHeight()-(vBorder+parseInt(parent.css("padding-top"))+parseInt(parent.css("padding-bottom"))));
		handleDependentResize(iContainer,iChain,iForceResize);
	}	
	
	Element.resizeSpecialElements(iContainer,iChain,iForceResize);
	
}
