// ######################## DEFINE ELEMENT     #########################
var elementID = 0;

var ELEMENTCLASSLIST = ".gridlayout,.containerElement,.scrollContainerElement,.textelement,.textinputelement,.imgelement,.linearlistlayout,.mapperelement,.verticalbarelement,.buttonelement,.sliderelement";

var Element = function(){
	this.element=null;
} 

Element.prototype.implement = function () {
	//console.log("Implement function element not implemented");
}

Element.prototype.afterInsert = function() {
	//console.log("afterInsert function element not implemented");
}

Element.prototype.setProperties = function (iProperties){
	this.prop=iProperties;
	return this;
}

Element.prototype.getInnerElements = function () {
	return [];
}

Element.markElement = function (iElement, iPropertyName, iProperty) {

	//console.log("Mark element :");
	//console.log(iElement);
	//console.log(iElement.element);
	iElement[iPropertyName] = iProperty;
	if (valid(iElement.element)) {
		$(iElement.element).data(iPropertyName,iProperty);
	}
	var elements = iElement.getInnerElements();
	//console.log("Number of inner elements:"+elements.length);
	for (var i=0; i<elements.length; i++) {
		Element.markElement(elements[i], iPropertyName, iProperty);
	}
	
}

Element.prototype.shiftZIndex = function (iIndex) {

	var aElement = $(this.element);
	var currentZIndex = aElement.css("z-index");
	aElement.css( 'z-index' , currentZIndex + iIndex );
	
	$.each( aElement.find(ELEMENTCLASSLIST),
			function(key,value) {
				var currentZIndex = $(value).css("z-index");
				$(value).css( 'z-index' , currentZIndex + iIndex );
			}
	);
	
	return this;

}

Element.prototype.hide = function () {

	var aElement = $(this.element);
	aElement.css("visibility","hidden");
	
	$.each( aElement.find(ELEMENTCLASSLIST),
			function(key,value) {
				$(value).css("visibility","hidden");
			}
	);
	
	return this;

}

Element.prototype.show = function () {

	var aElement = $(this.element);
	aElement.css("visibility","visible");
	
	$.each( aElement.find(ELEMENTCLASSLIST),
			function(key,value) {
				$(value).css("visibility","visible");
			}
	);

	return this;
	
}



Element.prototype.checkWrapping = function (iInnerElement){

	var propDefined = (!(typeof this.prop==="undefined")) && (this.prop!=null);
	// This will validate if the cell element is a container
	// If we are in wrap mode for the layout/container, we have to raise error/or setup container to wrap mode
	// Best is to set error to indicate an issue with the layout definition
	if (propDefined?!(typeof this.prop.wrap==="undefined"):false){

		if (this.prop.wrap==true) {
		
			var inError = true;
		
			if (iInnerElement instanceof ContainerElement) {
			
				if (!(typeof iInnerElement.prop==='undefined')) {
					
					if (!(typeof iInnerElement.prop.wrap==='undefined')){
					  if (iInnerElement.prop.wrap==true) {
						inError = false;
					  }
					} 
				
				} 
			
			} else if (iInnerElement instanceof ImageElement) {
			
				if (!(typeof iInnerElement.prop==='undefined')) {
					
					if (!(typeof iInnerElement.prop.wrap==='undefined')){
					  if (iInnerElement.prop.wrap==true) {
						inError = false;
					  }
					} 
				
				}

			} else { // The element is not a container nor an image, so self define its size
				inError = false;
			}
			
			if (inError) {
			
				console.log("Error: unable to wrap the container/image, please setup wrap mode for the container/image.");
				return new TextElement("#ERROR#");
			
			}
	
		}
		
	}
	
	return iInnerElement;

}

Element.resizeInChain = function (iObject, iElement, iResizeChain, iForceResize) {
	
	var id = $(iElement).attr('id')+"|";
	
	if (!valid(iResizeChain)) {
		iResizeChain = "|" ;
	}
	
	if (iResizeChain.length==1) {
	
		iResizeChain = iResizeChain + id ;
		iObject.resize(iElement, iResizeChain, iForceResize);
		
	} else {
	
		if ((iResizeChain.indexOf("|"+id)==-1)) {
		
			iResizeChain = iResizeChain + id ;
			iObject.resize(iElement, iResizeChain, iForceResize);
		
		} else {
		
			iResizeChain = iResizeChain + id ; 
			console.log("Detected loop:"+iResizeChain);
		
		}
	
	}
	
}

Element.prototype.insert = function (iElement) {
	var aElement = $(iElement);
	var html_code = this.implement();
	$(aElement).html(html_code);
	this.afterInsert();
	handleLayoutResize();
}

Element.resizeSpecialElements = function(iElement,iChain,iForceResize) {

	//console.log("Resize special element ...");
	// Here we ask to resize ScrollContainerElement if needed
	var aElement = $(iElement).parent().closest(ELEMENTCLASSLIST);
	if (valid(aElement)) {
	
		//console.log("Element");
		//console.log(aElement);
		if (aElement.hasClass( 'scrollContainerElement' )) {
			Element.resizeInChain(ScrollContainerElement,aElement,iChain,iForceResize);
		}
	
	}

}
