// ######################## DEFINE ELEMENT IMAGE ########################
var ImageElement = function(iSrc){
	Element.call(this);
	this.src = iSrc;
} 
ImageElement.prototype = new Element();
ImageElement.prototype.constructor = ImageElement;
	
ImageElement.prototype.setPosition = function (iPosition){
	this.position = iPosition;
	return this;
}

ImageElement.prototype.implement = function () {

	// at that step we have the image size
	/*console.log("Waited width :"+waitImage.width);
	//console.log("Waited height :"+waitImage.height);*/
	this.width = 0;
	this.height = 0;
	
	var html_code = "<div id='elem"+elementID+"' class='imgelement' style='";
	if (!(typeof this.position==="undefined")) {
		if (this.position=='center') {
			html_code = html_code + "text-align:center;"; // have to define the size
		} else if (this.position=='left') {
			html_code = html_code + "text-align:left;"; 
		} else if (this.position=='right') {
			html_code = html_code + "text-align:right;";
		}

	}
	var wrap = (!(typeof prop==="undefined")?prop.wrap:false);
	if (wrap) {
		html_code = html_code + "width:"+this.width+"px;"+"height:"+this.height+";";
	}
	html_code = html_code + "'><img  src='"+this.src+"' style='position:absolute' ></div>";

	this.id = elementID;
	this.element = "#elem"+elementID;
	elementID++;
	return html_code;
}

ImageElement.prototype.onClick = function (iOnClickFunction){
	this.onClickFunction = iOnClickFunction;
	return this;
}

ImageElement.afterInsertOnLoad = function(iElement,iWidth,iHeight) {

	$(iElement).data("imgwidth",iWidth);
	$(iElement).data("imgheight",iHeight);
	$(iElement).data("loaded",true);

	//console.log("ImageElement:"+$(iElement).attr('id'));
	//console.log("Width:"+iWidth);
	//console.log("Height:"+iHeight);
	
	ImageElement.resize($(iElement),"",true);
	
	$(iElement).show();	
	
}

ImageElement.onLoadFunction = function(iElement,iImage){
	return function(){
		//console.log("ImageElement:"+$(iElement).attr('id'));
		//console.log('Image loaded width:'+iImage.width);
		//console.log('Image loaded height:'+iImage.height);
		ImageElement.afterInsertOnLoad(iElement,iImage.width,iImage.height);
	}
}

ImageElement.prototype.afterInsert = function() {

	var aElement = this.element;
	
	if (valid(this.attached)) {
		$(aElement).data("attached",this.attached);
	}
	
	$(aElement).hide();
	
    var waitImage = new Image();
    waitImage.onload = ImageElement.onLoadFunction(aElement, waitImage);
    waitImage.src = this.src;
	
	$(this.element).data("prop",this.prop);
	if (valid(this.onClickFunction)) {
		console.log("On click function installed");
		$(this.element).click(this.onClickFunction);
		$(this.element).css('cursor', 'pointer');
	}
	
}

ImageElement.resize = function (iElement,iChain,iForceResize){
	
	
	var aElement = $(iElement);
	var imgWidth = aElement.data("imgwidth");
	var imgHeight = aElement.data("imgheight");
	var prop = aElement.data("prop");
	
	var ratio = imgWidth/imgHeight;
	
	var wrap = (!(typeof prop==="undefined")?prop.wrap:false);
	if (!wrap) {
		var elem = aElement.data("parentWrap");
		wrap = (typeof elem==="undefined"?false:elem);
	}
	
	if (!wrap) {
	
		var aParent = aElement.parent();
		var estWidth = aParent.width();
		var estHeight = Math.floor(estWidth/ratio);
		
		//console.log("Before EstWidth:"+estWidth);
		//console.log("Before EstHeight:"+estHeight);
		
		aElement.width(estWidth);
		aElement.height(aParent.height());
		
		if (estHeight>aParent.height()) {
		
			estHeight = aParent.height();
			estWidth = Math.floor(estHeight*ratio);
			
		}
		
		var aTop = (aParent.height()-estHeight)/2;
		var aLeft = (aParent.width()-estWidth)/2;
		
		aElement.find('img').css({ "top" : aTop, "left" : aLeft });
		
		//console.log("ratio:"+ratio);
		//console.log("EstWidth:"+estWidth);
		//console.log("EstHeight:"+estHeight);
		
		aElement.find('img').width(estWidth);
		aElement.find('img').height(estHeight);
		
	} else {
	
		aElement.width(imgWidth);
		aElement.height(imgHeight);
		
	}
	
	Element.resizeSpecialElements(iElement,iChain,iForceResize);
	
}