// ######################## DEFINE Container Element Scrollbar ###############

var ScrollContainerElement = function(iElement){
	Element.call(this);
	this.id = null;
	this.internalElement = iElement;
	
} 

ScrollContainerElement.prototype = new Element();
ScrollContainerElement.prototype.constructor = ScrollContainerElement;

ScrollContainerElement.prototype.setStyle = function(iStyle){
	this.style = iStyle;
}

ScrollContainerElement.prototype.setCanvasStyle = function(iCanvasStyle){
	this.cstyle = iCanvasStyle;
}

ScrollContainerElement.prototype.implement = function () {

	this.id = elementID;
	//this.internalElement.element = "#elem"+this.id; 
	this.element = "#elem"+this.id; 
	elementID++;
	
	// Here test wrapping definition
	this.internalElement = this.checkWrapping(this.internalElement);

	var html_code = "<div  id='elem"+this.id+"' class='scrollContainerElement ui-widget-content ui-corner-all' style='position: relative; overflow: hidden;"+(valid(this.style)?this.style:"")+"'>"+
				"<div class='scrollPanelElement' style='position: relative; "+(valid(this.cstyle)?this.cstyle:"")+" '>"+
					"<div  class='scrollCanvas' style='position:absolute; left: 0px; top: 0px; width:0px; height:0px;'>"+
						this.internalElement.implement()+
					"</div>"+
				"</div>"+
				"<div class='verticalScrollBar ui-widget-content ui-corner-right' style='position : absolute; top : 0px; left: 0px;' >"+
					"<div class='scrollbutton ui-widget-content ui-corner-all' style='position : absolute; top : 0px; left: 0px;' ></div>"+
				"</div>"+
				"<div class='horizontalScrollBar ui-widget-content ui-corner-bottom' style='position : absolute; top : 0px; left: 0px;'>"+
					"<div class='scrollbutton ui-widget-content ui-corner-all' style='position : absolute; top : 0px; left: 0px;' ></div>"+
				"</div>"+
			"</div>";
	return html_code;
}

ScrollContainerElement.prototype.getInnerElements = function () {
	return [this.internalElement];
}

var K_SIZE = 20;

ScrollContainerElement.verticalPlacement = function(iContainer){
	//var aContainer = $(ui.handle).closest(".scrollContainerElement").parent();
	var aRecord = $(iContainer).data('prop');
	var aCanvas = $(iContainer).find(".scrollCanvas");
	var vPercent = $(iContainer).data('vPercent');
	
	//console.log(aRecord);
	
	if (!(typeof aRecord==='undefined')) {
	
		//console.log(aRecord.vBar);
		if ( aRecord.vBar ) {
			
			var aYPosition = (vPercent*(aRecord.vBarCSize-$(aCanvas).height()))/100;
			
			//console.log("Y position :"+aYPosition);
			//console.log((aCanvas));
			$(aCanvas).css({ top : aYPosition+"px" });
			
		}
		
	}
}

ScrollContainerElement.horizontalPlacement = function(iContainer){
	
	var aRecord = $(iContainer).data('prop');
	var aCanvas = $(iContainer).find(".scrollCanvas");
	var hPercent = $(iContainer).data('hPercent');
	
	//console.log(aRecord);
	
	if (!(typeof aRecord==='undefined')) {
	
		//console.log(aRecord.hBar);
		if ( aRecord.hBar ) {
			
			var aXPosition = (hPercent*(aRecord.hBarCSize-$(aCanvas).width()))/100;
			
			//console.log("X position :"+aXPosition);
			//console.log(aCanvas);
			$(aCanvas).css({ left : aXPosition+"px" });
			
		}
		
	}
}

// Vertical Management
ScrollContainerElement.verticalButtonMouseDown = function(iEvent,iElement) {

	//console.log("Mouse down event on verticalButton");
	//console.log(iElement);
	
	$(iElement).data('vActivated',true);
	$(iElement).data('vMPos',iEvent.pageY);
	
}

ScrollContainerElement.verticalButtonMouseUp = function(iEvent,iElement) {
	
	//console.log("Mouse up event on verticalButton");
	//console.log(iElement);
	
	$(iElement).data('vActivated',false);
	
}

ScrollContainerElement.verticalButtonMouseMove = function(iEvent,iElement) {

	var aActivated = $(iElement).data('vActivated');
	if (aActivated) {
	
		var vMousePos = iEvent.pageY;
		var vPrecedingPos = $(iElement).data('vMPos');
		var vmove = vMousePos-vPrecedingPos;
		
		var aButton = $(iElement).find( ".verticalScrollBar" ).find(".scrollbutton");
		var aTop = parseInt(aButton.css('top'),10);
		aTop = aTop + vmove;
		
		var aVMax = $(iElement).data('vMax');
		
		if (aTop<0) {
		  aTop = 0;
		} else if (aTop>=aVMax) {
		  aTop = aVMax;	
		}
		
		aButton.css({top:aTop});
		
		var aPercent = aTop*100/aVMax;
		//console.log("VPos:"+aPercent+"%");
		$(iElement).data('vPercent', aPercent);
		$(iElement).data('vMPos',vMousePos);
	
		ScrollContainerElement.verticalPlacement($(iElement));
	
	}

}

ScrollContainerElement.verticalButtonMouseEnter = function(iEvent,iElement) {

	//console.log("Mouse enter event on verticalButton");
	//console.log(iEvent);
	
	if (iEvent.buttons==0) {
		$(iElement).data('vActivated',false);
	}
	
}

ScrollContainerElement.verticalBarClick = function(iEvent,iElement) {

	//console.log("Vertical bar click :");
	
	//var aVerticalBar = $(iElement).find( ".verticalScrollBar" );
	var aButton = $(iElement).find( ".verticalScrollBar" ).find(".scrollbutton");
	var aButtonPos = $(aButton).offset().top;
	
	var aMax = $(iElement).data('vMax');
	var vPercent = $(iElement).data('vPercent');
	
	if (aButtonPos>iEvent.pageY) {
		
		//console.log("top");
		
		vPercent = vPercent - 5;
		if (vPercent<0) {
			vPercent = 0;
		}
		
		
	} else {
		
		//console.log("bottom");
		
		vPercent = vPercent + 5;
		if (vPercent>100) {
			vPercent = 100;
		}
		
	}
	
	var aTop = vPercent*aMax/100;
	$(aButton).css({top:aTop+'px'});
	$(iElement).data('vPercent',vPercent);
	
	ScrollContainerElement.verticalPlacement($(iElement));
	
}

ScrollContainerElement.horizontalButtonMouseDown = function(iEvent,iElement) {

	//console.log("Mouse down event on horizontalButton");
	//console.log(iElement);
	
	$(iElement).data('hActivated',true);
	$(iElement).data('hMPos',iEvent.pageX);
	
}

ScrollContainerElement.horizontalButtonMouseUp = function(iEvent,iElement) {
	
	//console.log("Mouse up event on horizontalButton");
	//console.log(iElement);
	
	$(iElement).data('hActivated',false);
	
}

ScrollContainerElement.horizontalButtonMouseMove = function(iEvent,iElement) {

	var aActivated = $(iElement).data('hActivated');
	if (aActivated) {
	
		var hMousePos = iEvent.pageX;
		var hPrecedingPos = $(iElement).data('hMPos');
		var hmove = hMousePos-hPrecedingPos;
		
		var aButton = $(iElement).find( ".horizontalScrollBar" ).find(".scrollbutton");
		var aLeft = parseInt(aButton.css('left'),10);
		aLeft = aLeft + hmove;
		
		var aHMax = $(iElement).data('hMax');
		
		if (aLeft<0) {
		  aLeft = 0;
		} else if (aLeft>=aHMax) {
		  aLeft = aHMax;	
		}
		
		aButton.css({left:aLeft});
		
		var aPercent = aLeft*100/aHMax;
		//console.log("VPos:"+aPercent+"%");
		$(iElement).data('hPercent', aPercent);
		$(iElement).data('hMPos',hMousePos);
		
		ScrollContainerElement.horizontalPlacement($(iElement));
		
	}

}

ScrollContainerElement.horizontalButtonMouseEnter = function(iEvent,iElement) {

	//console.log("Mouse enter event on verticalButton");
	//console.log(iEvent);
	
	if (iEvent.buttons==0) {
		$(iElement).data('hActivated',false);
	}
	
}

ScrollContainerElement.horizontalBarClick = function(iEvent,iElement) {

	//console.log("Horizontal bar click :");
	
	var aButton = $(iElement).find( ".horizontalScrollBar" ).find(".scrollbutton");
	var aButtonLeft = $(aButton).offset().left;
	
	var aMax = $(iElement).data('hMax');
	var hPercent = $(iElement).data('hPercent');
	
	if (aButtonLeft>iEvent.pageX) {
		
		//console.log("left");
		
		hPercent = hPercent - 5;
		if (hPercent<0) {
			hPercent = 0;
		}
		
		
	} else {
		
		//console.log("right");
		
		hPercent = hPercent + 5;
		if (hPercent>100) {
			hPercent = 100;
		}
		
	}
	
	var aLeft = hPercent*aMax/100;
	$(aButton).css({left:aLeft+'px'});
	$(iElement).data('hPercent',hPercent);
	
	ScrollContainerElement.horizontalPlacement($(iElement));
}

ScrollContainerElement.prototype.afterInsert = function() {

	//console.log("after insert ScrollContainerElement");
	
	// Vertical Scroll Bar
	var aElement = $(this.element);
	
	aElement.data('vActivated',false);
	aElement.data('vPercent',0);
	aElement.data('hActivated',false);
	aElement.data('hPercent',0);
	
	var vscrollbar = aElement.find( ".verticalScrollBar" );
	var vButton = vscrollbar.find( ".scrollbutton" );
	vscrollbar.click(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.verticalBarClick(e,aElement);
	});
	
	vButton.append( "<span class='ui-icon ui-icon-grip-dotted-horizontal'></span>" );
	vButton.mousedown(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.verticalButtonMouseDown(e,aElement);
	});
	vButton.mouseenter(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.verticalButtonMouseEnter(e,aElement);
	});
	vButton.mousemove(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.verticalButtonMouseMove(e,aElement);
	});
	vButton.mouseup(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.verticalButtonMouseUp(e,aElement);
	});
	
	// Horizontal Scroll Bar
	var hscrollbar = aElement.find( ".horizontalScrollBar" );
	var hButton = hscrollbar.find( ".scrollbutton" );
	hscrollbar.click(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.horizontalBarClick(e,aElement);
	});
	
	hButton.append( "<span class='ui-icon ui-icon-grip-dotted-vertical'></span>" );
	hButton.mousedown(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.horizontalButtonMouseDown(e,aElement);
	});
	hButton.mouseenter(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.horizontalButtonMouseEnter(e,aElement);
	});
	hButton.mousemove(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.horizontalButtonMouseMove(e,aElement);
	});
	hButton.mouseup(function(e){
		e.preventDefault();
		e.stopPropagation();
		ScrollContainerElement.horizontalButtonMouseUp(e,aElement);
	});
	
	$(this.internalElement.element).data("parentWrap",true); // The inner element have are wrapped by parents
	this.internalElement.afterInsert();
	
	ScrollContainerElement.resize(aElement);
	
}

// Static method
ScrollContainerElement.resize = function (iContainer,iChain,iForceResize){
	
	//console.log("Resize Scroll Container");
	//console.log(iContainer);
	
	var aContainer = $(iContainer);
	
	// Define container size
	var aParent = aContainer.parent();
	
	var hBorder = aContainer.outerWidth()-aContainer.innerWidth();
	var vBorder = aContainer.outerHeight()-aContainer.innerHeight();
	
	var innerWidth = aParent.innerWidth()-(hBorder+parseInt(aParent.css("padding-left"))+parseInt(aParent.css("padding-right")));
	var innerHeight = aParent.innerHeight()-(vBorder+parseInt(aParent.css("padding-top"))+parseInt(aParent.css("padding-bottom")));
	
	aContainer.width(innerWidth);
	aContainer.height(innerHeight);
	
	// Define scroll panel size
	var aScrollPanel = aContainer.children(".scrollPanelElement");
	//console.log(aScrollPanel);
	aScrollPanel.width(innerWidth);
	aScrollPanel.height(innerHeight);

	// Find elements Canvas, VScrollBar , HScrollBar
	var aScrollCanvas = aScrollPanel.children(".scrollCanvas");
	var aVScrollBar = aContainer.children(".verticalScrollBar");
	var aHScrollBar = aContainer.children(".horizontalScrollBar");
	
	// Resize contained element
	//console.log("Resizing the content:");
	//console.log(aScrollCanvas);
	handleDependentResize(aScrollCanvas,iChain,iForceResize);
	
	// Resize canvas
	var children = aScrollCanvas.children();
	//console.log(children);
	aScrollCanvas.width(children.outerWidth());
	aScrollCanvas.height(children.outerHeight());
	
	var vContWidth = aContainer.innerWidth();
	var vContHeight = aContainer.innerHeight();
	
	var cWidthSize = aScrollCanvas.width();
	var cHeightSize = aScrollCanvas.height();
	
	var vScrollBar = false;
	var hScrollBar = false;
	
	// Test Width/Height
	if ( cHeightSize > vContHeight) {
		vScrollBar = true;
		vContWidth = vContWidth-K_SIZE;
	}
	
	if ( cWidthSize > vContWidth ) {
		hScrollBar = true;
		vContHeight = vContHeight-K_SIZE;
	}
	
	if ((!vScrollBar) && (cHeightSize > vContHeight)) {
		vScrollBar = true;
		vContWidth = vContWidth-K_SIZE;
	}
	
	// three times to detect all cases
	
	if (vScrollBar) {
	
		aVScrollBar.show();
		aVScrollBar.css({ top: "0px", left : (vContWidth+2)+"px" });
		aVScrollBar.width(K_SIZE);
		aVScrollBar.height(vContHeight+1);
		
		var cursorSize =  (1-(cHeightSize - vContHeight)/cHeightSize)*vContHeight;
		if (cursorSize<16) {
			cursorSize = 16;
		}
		//console.log("Cursor height size:"+cursorSize);
		var aButton = aVScrollBar.find( ".scrollbutton");
		aButton.height(cursorSize);
		
		var hBorder = aButton.outerWidth()-aButton.innerWidth();
		var innerWidth = K_SIZE-(hBorder*2);
		aButton.width(innerWidth);
		
		//aElement.data('vActivated',false);
		var vBorder = aButton.outerHeight()-aButton.innerHeight();
		var aMax = vContHeight-(aButton.outerHeight()+vBorder);
		
		var vPercent = aContainer.data('vPercent');
		var aTop = vPercent*aMax/100;
		aButton.css({top:aTop+'px'});
		
		aContainer.data('vMax',aMax);
		
	} else {
	
		aVScrollBar.hide();
	
	}
	
	if (hScrollBar) {
		
		aHScrollBar.show();
		aHScrollBar.css({ top: (vContHeight+2)+"px", left : "0px" });
		aHScrollBar.width(vContWidth+1);
		aHScrollBar.height(K_SIZE);
		
		var cursorWidthSize =  (1-(cWidthSize - vContWidth)/cWidthSize)*vContWidth;
		if (cursorWidthSize<16) {
			cursorWidthSize = 16;
		}
		//console.log("Cursor width size:"+cursorWidthSize);
		var aButton = aHScrollBar.find( ".scrollbutton");
		aButton.width(cursorWidthSize);
		
		var vBorder = aButton.outerHeight()-aButton.innerHeight();
		var innerHeight = K_SIZE-(vBorder*2);
		aButton.height(innerHeight);
		
		var hBorder = aButton.outerWidth()-aButton.innerWidth();
		var aMax = vContWidth-(aButton.outerWidth()+hBorder);
		
		var hPercent = aContainer.data('hPercent');
		var aLeft = hPercent*aMax/100;
		aButton.css({left:aLeft+'px'});
		
		aContainer.data('hMax',aMax);
		
	} else {
		
		aHScrollBar.hide();
		
	}
	
	aContainer.data('prop', { hBar : hScrollBar, vBar : vScrollBar, vBarCSize : vContHeight , hBarCSize : vContWidth } );
		
}