// ######################## DEFINE ELEMENT SLIDER ######################
var SliderElement = function(iValue, iRange, iCallback){
	Element.call(this);
	this.value = iValue;
	this.range = iRange;
	this.callback = iCallback;
} 
SliderElement.prototype = new Element();
SliderElement.prototype.constructor = SliderElement;

SliderElement.prototype.setSize = function (iWidth,iHeight){
	this.width = iWidth;
	this.height = iHeight;
}

SliderElement.prototype.setRange = function (iRange){
	this.range = iRange;
}

SliderElement.prototype.setBackgroundColor = function (iColor){
	this.backgroundColor = iColor;
}

SliderElement.prototype.implement = function () {
	this.id  = elementID;
	this.element = "#elem"+elementID;
	var html_code = "<div id='elem"+elementID+"' class='sliderelement' ><div class='inner'></div></div>";
	elementID++;
	return html_code;
}

SliderElement.prototype.afterInsert = function() {

	var aRange = "min";
	if (valid(this.range)) {
		aRange = this.range;
	}

	$(this.element).find('.inner').slider({
		value: this.value,
		values: this.value,
		orientation: "horizontal",
		range: aRange,
		min : this.range.min,
		max : this.range.max,
		slide: this.callback
	});
	
	if (valid(this.backgroundColor)) {
		$(this.element).css("backgroundColor",this.backgroundColor);
		$(this.element).find(".inner").css({ "backgroundColor" : this.backgroundColor,
											 "backgroundImage" : "none" } );
	}
	$(this.element).find(".inner").css({"border": "0px"});
	
	$(this.element).data('width',this.width);
	$(this.element).data('height',this.height);
	$(this.element).data('value',this.value);
	$(this.element).data('min',this.range.min);
	$(this.element).data('max',this.range.max);
	$(this.element).data('callback',this.callback);
}

SliderElement.resize = function (iElement,iChain,iForceResize){
	
	var aElement = $(iElement);
	var aInner = $(iElement).find(".inner");
	var aHandle = $(iElement).find(".inner").find("a");
	var aSlider = $(iElement).find(".inner").find("div");
	
	var wrap = (!(typeof prop==="undefined")?prop.wrap:false);
	if (!wrap) {
		var elem = aElement.data("parentWrap");
		wrap = (typeof elem==="undefined"?false:elem);
	}
	
	var width = 0;
	var height = 0;
	if (!wrap) {
		var aParent = aElement.parent();
		width = aParent.width();
		height = aParent.height();
	} else {
		width = aElement.data("width");
		height = aElement.data("height");
	}
	
	aElement.width(width);
	aElement.height(height);
	
	aInner.width(width-height);
	aInner.height(height);
	aInner.css("left","0px");
	
	// margin-left margin-right
	aSlider.height(height);
	
	aHandle.css({"padding" : "0px"});
	aHandle.css({"margin-left" : "0px" });
	aHandle.width(height-4);
	aHandle.height(height-4);
	
	var aTop = (aElement.height()-aHandle.outerHeight())/2;
	aHandle.css("top", aTop+"px");
	
	Element.resizeSpecialElements(iElement,iChain,iForceResize);
	
}

// TODO implement resize