// ######################## DEFINE ELEMENT TEXT ########################
var TextElement = function(iText){
	Element.call(this);
	iText = iText.replace(/ /g,"&nbsp;"); 
	this.text = iText;
} 
TextElement.prototype = new Element();
TextElement.prototype.constructor = TextElement;

TextElement.hashcall = function(iHash) {
	
	//console.log("TextElement check for page load ...");
	//console.log(iHash);
	
	var aSplit = getHashSplit(iHash);
	
	var aUrl;
	$.each( $(document).find(".textelement") , function(key,value) {
	
		var hashes = $(value).data("hashes");
		if (valid(hashes)){
		
			if (Object.size(hashes)>0) {
				//console.log("Text element contains hashes:");
				//console.log(value);
				if (valid(hashes[aSplit.HA])) {
					aUrl = hashes[aSplit.HA];
				}
			}
			
		}
		
	});
	
	if (valid(aUrl)) {
	
		//console.log("Load item from url :");
		var aTargetElement = $("#"+aSplit.LTO);
		var aTextElement = aTargetElement.closest(".textelement");
		aTextElement.data('ishtmltext',true);
			
		var linkColor = aTextElement.data('linkcolor');
		var aContext = {};
		aContext.linkColor = linkColor;
		var textValue = TextElement.load(aUrl);
	
		textValue = TextElement.parseHTML(aContext,textValue);
		aContext.id = "#"+aTextElement.attr('id');
	
		aTargetElement.empty();
		aTargetElement.append(textValue);
		
		TextElement.postInsertBuildLinks(aContext);
		
		TextElement.resize(aTextElement);
	
	}
	
}

HashCall.pushHashFunction(TextElement.hashcall);

TextElement.prototype.isUrl = function(){
	this.url = true;
	this.htmltext = true;
}

TextElement.prototype.isHTMLText = function(){
	this.htmltext = true;
}


TextElement.prototype.setFontSize = function (iSize){
	this.size = iSize;
	return this;
}
	
TextElement.prototype.setStyle = function (iStyle){
	this.style = iStyle;
	return this;
}	
	
TextElement.prototype.setPosition = function (iPosition){
	this.position = iPosition;
	return this;
}

TextElement.prototype.setVerticalPosition = function (iPosition){
	this.vposition = iPosition;
	return this;
}

TextElement.prototype.setColor = function (iColor){
	this.color = iColor;
	return this;
}

TextElement.prototype.onClick = function (iOnClickFunction){
	this.onClickFunction = iOnClickFunction;
	return this;
}

TextElement.prototype.link = function (iLink){
	this.linked = iLink;
	return this;
}

TextElement.prototype.setMouseOverColor = function (iColor){
	this.onMouseOverColor = iColor;
	return this;
}

TextElement.prototype.setMouseOverBkColor = function (iColor){
	this.onBkMouseOverColor = iColor;
	return this;
}

TextElement.prototype.setLinkColor = function (iColor){
	this.linkColor = iColor;
	return this;
}

TextElement.prototype.translate = function(iField){
	this.translate = iField;
	return this;
}

TextElement.prototype.implement = function () {
    this.id  = elementID;
	this.element = "#elem"+elementID;
	var html_code = "<div id='elem"+elementID+"' class='textelement ui-widget' style='text-align:justify; position:absolute; top:0px; left:0px;  ";
	elementID++;
	if (valid(this.size)) {
		html_code = html_code + "font-size:"+this.size+";";
	}

	if (!(typeof this.color==="undefined")) {
		html_code = html_code + "color : "+this.color+";";
	}
	
	if (valid(this.style)) {
		html_code = html_code + this.style;
	}
	
	var textValue = this.text;
	if (!(typeof this.translate==="undefined")) {
		textValue = International.translate( Layout.language , this.translate, textValue);
	}
	
	if (this.url) {
	
		//console.log("The text represent an url");
		textValue = TextElement.load(textValue);
	
	}
	
	var aContext={};
	aContext.linkColor = this.linkColor;
	textValue = TextElement.parseHTML(aContext,textValue);
	aContext.id = this.element;
	//console.log("Context:");
	//console.log(aContext);
	this.context = aContext;
	
	if (!(typeof this.linked==="undefined")) {
		html_code = html_code + "'><a href='"+this.linked+"'>"+textValue+"</a></div>";
	} else {
		html_code = html_code + "'>"+textValue+"</div>";
	}
	return html_code;
}

// Here is the text parser that handle small internal functionnalities
// tag {r:[ref]:[url]}[Text]{:} indicate to load data from url inside ref text element
// tag {d:[ref]}                declares a reference, i.e. text will be included there
// tag {f:[function]}		    call a function
// This is a functionnality outside the layout parser to work quickly (Quick and Dirty)

TextElement.refNumber = 0;

TextElement.parseTAG = function(iContext,iHTML,iTagType){

	var aHtml = "";

	if (iTagType=="r") { // define a link with inner text
		
		// extract the tag name
		var aRef = "";
		s = iHTML.indexOf(":");
		if (s==-1) {
			logError("TextElement : no ref defined from url file.");
			return;
		}
		aRef =  iHTML.substring(0,s);
		iHTML = iHTML.substring(s+1);
		
		// extract the url
		var aUrl = "";
		s = iHTML.indexOf("}");
		if (s==-1) {
			logError("TextElement : no url defined .");
			return;
		}
		aUrl = iHTML.substring(0,s);
		iHTML = iHTML.substring(s+1);
		
		iContext.refs.push({
			TY	: 'r',
			ID  : 'ref'+TextElement.refNumber,
			TO  : aRef,
			URL : aUrl 
		});
		
		iContext.hashes[aUrl.hashCode()] = aUrl;
		
		aHtml = "<span id='ref"+TextElement.refNumber+"' ";
		if (valid(iContext.linkColor)) {
			aHtml += "style='color:"+iContext.linkColor+"'>";
		} else {
			aHtml += ">";
		}
		TextElement.refNumber++;
		
	} else if (iTagType=="f") {
	
		// extract the function name
		var aFunction = "";
		s = iHTML.indexOf("}");
		if (s==-1) {
			logError("TextElement : no function defined .");
			return;
		}
		aFunction = iHTML.substring(0,s);
		iHTML = iHTML.substring(s+1);
		
		iContext.refs.push({
			TY	: 'f',
			ID  : 'ref'+TextElement.refNumber,
			FU  : aFunction
		});
	
		aHtml = "<span id='ref"+TextElement.refNumber+"' ";
		if (valid(iContext.linkColor)) {
			aHtml += "style='color:"+iContext.linkColor+"'>";
		} else {
			aHtml += ">";
		}
		TextElement.refNumber++;
	
	} else if (iTagType=="d") { // define a reference
		
		// extract the url
		var aRef = "";
		s = iHTML.indexOf("}");
		if (s==-1) {
			logError("TextElement : no reference defined .");
			return;
		}
		aRef =  iHTML.substring(0,s);
		iHTML = iHTML.substring(s+1);
		
		aHtml = "<span id='"+aRef+"'></span>";
		
	} else if (iTagType=="") { // closing tab i.e  {:}
		
		s = iHTML.indexOf("}");
		if (s==-1) {
			logError("TextElement : no closing bracket defined.");
			return;
		}
		iHTML = iHTML.substring(s+1);
		
		aHtml = "</span>";
		
	} else {
		logError("TextElement : invalid tag '"+iTagType+"'.");
		return;
	}

	return {
		"entry" : iHTML,
		"html"  : aHtml
	};
	
}

TextElement.parseHTML = function(iContext,iHTML){

	var html_code = "";
	
	if (typeof iHTML==="number") {
		iHTML = iHTML.toString();
	}
	
	iContext.refs = [];
	iContext.hashes = {};

	var s = iHTML.indexOf("{");
	while (s!=-1) {
	
		if ((s==0) || (iHTML.charAt(s-1)!="\\")) { // this permit to define '{' => '\{'
		
			// Remove entry character
			html_code += iHTML.substring(0,s);
			iHTML = iHTML.substring(s+1);
		
			// Find Tag type
			var aTagType = "";
			s = iHTML.indexOf(":");
			aTagType =  iHTML.substring(0,s);
			iHTML = iHTML.substring(s+1);
			
			var result = TextElement.parseTAG(iContext,iHTML,aTagType);
			
			if (valid(result)) {
				iHTML = result.entry;
				html_code += result.html;
			}
		
		} else {
		
			// We have to skip the parsing
			html_code += iHTML.substring(0,s-1) + "{" ;
			iHTML = iHTML.substring(s+1);
		
		}
		
		s = iHTML.indexOf("{");
		
	}
	html_code = html_code + iHTML;

	return html_code;

}

TextElement.elementLinkBuilder = function(iUrlHash,iTo) {
	return function() {
		
		// Build the event to call
		//console.log("To id:"+iTo);
		//console.log("Generated hash for url:"+iUrlHash);
		
		// Here call the history
		var aSplit = getLocationSplit();
		aSplit.LTO = iTo;
		aSplit.HA = iUrlHash;
		$.history.load(buildLocationHash(aSplit));
		
	};
}

TextElement.postInsertBuildLinks = function(iContext) {

	if (valid(iContext.refs)) {
	
		//console.log('Add hashes to the element:'+iContext.id);
		$(iContext.id).data("hashes",iContext.hashes);
	
		for (var i=0; i<iContext.refs.length; i++) {
			
			var aElement = $("#"+iContext.refs[i].ID);
			//console.log(iContext.refs[i]);
			//console.log(aElement);
			
			if (valid(aElement)) {
				if (iContext.refs[i].TY=="r") {
					aElement.click(TextElement.elementLinkBuilder(iContext.refs[i].URL.hashCode(),iContext.refs[i].TO));
				} else if (iContext.refs[i].TY=="f") {
					// pass function name
					aElement.click(eval(iContext.refs[i].FU));
				}
				aElement.css('cursor', 'pointer');
			}
			
		}
	
	}

}

TextElement.load = function(iUrl) {
	
	var html_code = "";
	$.ajaxSetup( { "async": false } );
	$.get(iUrl, function(data) {
		//console.log(data);
		html_code = data;
	},"html");
	$.ajaxSetup( { "async": true } );
	
	return html_code;

}

TextElement.changeLanguage = function(iElement){

	var aElement = $(iElement);
	var linked = aElement.data("linked");
	var translate = aElement.data("translate");
	
	var textValue = aElement.data("text");
	//console.log("Element");
	//console.log(aElement);
	//console.log("Text value:"+textValue);
	if (!(typeof translate==="undefined")) {
	
		textValue = International.translate( Layout.language , translate, textValue);
	
		var isUrl = aElement.data("isurl");
		if (isUrl) {
			//console.log("The text represent an url");
			textValue = TextElement.load(textValue);
		}
		
		var aContext={};
		aContext.linkColor = aElement.data("linkcolor");
		textValue = TextElement.parseHTML(aContext,textValue); // TODO Find a way to retrieve text element
		aContext.id = aElement.attr('id');
		
		var html_code = "";
		
		if (!(typeof linked==="undefined")) {
			html_code = html_code + "<a href='"+linked+"'>"+textValue+"</a>";
		} else {
			html_code = html_code + ""+textValue+"";
		}
		
		aElement.empty();
		aElement.append(html_code);
		
		TextElement.postInsertBuildLinks(aContext);
	
	}
	
}

TextElement.onMouseEnterCB = function(aElement){

	//console.log("Mouse Enter");
	var color = $(aElement).data('onMouseOverColor');
	var bkcolor = $(aElement).data('onBkMouseOverColor');
	if (valid(color)) {$(aElement).css("color",color);}
	if (valid(bkcolor)) {$(aElement).css("backgroundColor",bkcolor);}

}

TextElement.onMouseOutCB = function(aElement){

	//console.log("Mouse Out");
	var color = $(aElement).data('color');
	var bkcolor = $(aElement).data('bkcolor');
	if (valid(color)) {$(aElement).css("color",color);}
	if (valid(bkcolor)) {$(aElement).css("backgroundColor",bkcolor);}

}

TextElement.prototype.updateText = function(iText, iTranslate){
	
	iText = iText.replace(/ /g,"&nbsp;"); 
	
	var aElement = $(this.element);
	
	this.text = iText; // in case of layout not inserted
	
	aElement.data("text",iText);
	if (valid(iTranslate)) {
		aElement.data("translate",iTranslate);
	}
	
	TextElement.changeLanguage(this.element);

	TextElement.resize(this.element);

}

/*
TextElement.linksCallback =  function(iElement) {
	return function() {
		TextElement.hashcall(iElement.element);
	};
}
*/

TextElement.prototype.afterInsert = function() {

	//console.log("after insert text element ");
	//console.log($(this.element));
	
	var aElement = $(this.element);
	
	aElement.disableSelection();
	
	if (!(typeof this.onClickFunction==="undefined")) {
		aElement.click(this.onClickFunction);
		aElement.css('cursor', 'pointer');
	}
	
	aElement.data("position",this.position);
	aElement.data("vposition",this.vposition);
	aElement.data("isurl",this.url);
	aElement.data("ishtmltext",this.htmltext);
	aElement.data("translate",this.translate);
	aElement.data("linked",this.linked);
	//console.log("Insert Text");
	//console.log(aElement);
	//console.log("Text value:"+this.text);
	aElement.data("text",this.text);
	//console.log("Text recorded:"+aElement.data("text"));
	aElement.data("linkcolor",this.linkColor);
	if (valid(this.color)) {
		aElement.data("color",this.color);
	} else {
		aElement.data("color",aElement.css("color"));
	}
	
	aElement.data("bkcolor",aElement.css("backgroundColor"));
	
	if (valid(this.onMouseOverColor) || valid(this.onBkMouseOverColor)) {
	
		//console.log("add mouse listener :"+this.onMouseOverColor);
	
		aElement.data("onMouseOverColor",this.onMouseOverColor);
		aElement.data("onBkMouseOverColor",this.onBkMouseOverColor);
		
		aElement.mouseenter(function(e){
			TextElement.onMouseEnterCB(aElement);
		});
		aElement.mouseout(function(e){
			TextElement.onMouseOutCB(aElement);
		});
	
	}
	
	TextElement.postInsertBuildLinks(this.context);
	
	TextElement.resize(this.element);
	
}

TextElement.resize = function(iElement,iChain,iForceResize) {

	//console.log("resize text element ");
	//console.log($(iElement));
	
	var textelement = $(iElement);
	var parentElement = textelement.parent();
	
	var elem = textelement.data("parentWrap");
	var wrap = (typeof elem==="undefined"?false:elem);

	//console.log('wrap:'+wrap);
	
	if (wrap) {
	
		textelement.css({ top : "0px" , left : "0px" });
		textelement.height( textelement.textHeight() );
		textelement.width( textelement.textWidth() );
	
	} else {
	
		var position = textelement.data("position");
		var vposition = textelement.data("vposition");
		var ishtmltext = textelement.data("ishtmltext");
		//console.log("Position="+position);
		//console.log("V Position="+vposition);
		
		var fontHeight = textelement.textHeight();
		var fontWidth = textelement.textWidth();
		textelement.height(fontHeight);
		textelement.width(fontWidth);
		
		//console.log("Width:"+fontWidth);
		//console.log("Height:"+fontHeight);
		
		var aWantedHeight = parentElement.height();
		var aWantedWidth = parentElement.width();
		
		var aLeft=0;
		if (aWantedWidth>fontWidth) {
			if (!(typeof position==="undefined")) {
				
				if (ishtmltext) {
				
					//console.log('html text');
					var aBorders = textelement.outerWidth(true)-textelement.innerWidth();
					//console.log("Border Size:"+aBorders);
					textelement.width(aWantedWidth-aBorders);
				
				} else {
				
					if (position=="center") {
						aLeft = (aWantedWidth-fontWidth)/2;
					} else if (position=="right") {
						aLeft = aWantedWidth-fontWidth;
					} else if (position=="left") {
						aLeft = 0;
					}
			
				}
				
			} 
			
		} else {
			textelement.width(aWantedWidth);
		} 
		
		var aTop=0;
		if (valid(vposition)) {
		
			if (vposition=='center') {
				aTop = ((aWantedHeight-fontHeight)/2);
			} else if (vposition=='bottom') {
				aTop = aWantedHeight-fontHeight;
			} else {
				aTop = 0;
			}
		
		} else {
			aTop = ((aWantedHeight-fontHeight)/2); // Centering text by default
		}

		textelement.css({ top : aTop , left : aLeft });
		
	}
	
	Element.resizeSpecialElements(iElement,iChain,iForceResize);
	
}