// ######################## DEFINE ELEMENT TEXT INPUT ##################
var TextInputElement = function(iText,iType){
	Element.call(this);
	this.text = iText;
	this.type = iType;
	this.padding = 5;
} 
TextInputElement.prototype = new Element();
TextInputElement.prototype.constructor = TextInputElement;

TextInputElement.prototype.setFontSize = function (iSize){
	this.size = iSize;
	return this;
}
	
TextInputElement.prototype.setPosition = function (iPosition){
	this.position = iPosition;
	return this;
}

TextInputElement.prototype.setColor = function (iColor){
	this.color = iColor;
	return this;
}

TextInputElement.prototype.setPadding = function (iPadding){
	this.padding = iPadding;
	return this;
}

TextInputElement.prototype.setAutoComplete = function (iSourceFunction, iSelectFunction, iMinLength, iOptions) {
	this.sourceFunction = iSourceFunction;
	this.selectFunction = iSelectFunction;
	this.minLength = iMinLength;
	this.autocompleteOptions = iOptions;
	return this;
}

TextInputElement.prototype.setColorDescription = function (iColorDescription){
	this.colorDescription = iColorDescription;
	return this;
}


TextInputElement.prototype.setFollowing = function (iInputElement){
	this.following = iInputElement;
	return this;
}

TextInputElement.prototype.onValidation = function (iValidateFunction){
	this.validate = iValidateFunction;
	return this;
}

TextInputElement.prototype.setKeyPressedFunction = function (iFunction){
	this.keypressFunction = iFunction;
	return this;
}

TextInputElement.prototype.translate = function(iField){
	this.translate = iField;
	return this;
}

TextInputElement.prototype.implement = function () {
    this.id  = elementID;
	this.element = "#elem"+elementID;
	
	var html_code ="";
	html_code = "<form class='textinputelement' style='position:relative; margin:0px; padding:0px; border 0px; width:100%; height:100%;'><input type='text' name='none' style='border :0px; width:0px; height:0px; {display:none}'/>";
	
	// Create html input code to be doubled when password type
	var html_input_code ="";
	if ($.browser.msie) {	
		html_input_code = "<input class='tieInput ui-autocomplete-input ui-corner-all' style='position:absolute; border:0px; top:0px; left:0px; margin:0px; padding:0px; ";
	} else {
		html_input_code = "<input class='tieInput ui-autocomplete-input ui-corner-all' style='display:block; position:absolute; border:0px; top:0px; left:0px; margin:0px; padding:0px; ";
	}					
	
	if (valid(this.size)) {
		html_input_code += "font-size:"+this.size+";";
	}
	if (!(typeof this.position==="undefined")) {
		if (this.position=='center') {
			html_input_code += "text-align:center;"; // have to define the size
		} else if (this.position=='left') {
			html_input_code += "text-align:left;"; 
		} else if (this.position=='right') {
			html_input_code += "text-align:right;";
		}

	}
	
	if (!(typeof this.color==="undefined")) {
		html_input_code += "color : "+this.colorDescription+";";
	}
	
	var html_input_code_hidden="";
	if (this.type=="password") {
		
		html_input_code_hidden = html_input_code + "{display:none}'";
		html_input_code_hidden += " id='elem"+elementID+"_H' type='"+this.type+"'";
		html_input_code_hidden += ">";
	} 
		
	html_input_code += "'";
		
	if (!(typeof this.text==="undefined")) {
		var textValue = this.text;
		if (!(typeof this.translate==="undefined")) {
			textValue = International.translate( Layout.language , this.translate, this.text);
		}
		html_input_code += " value='" + textValue + "'";
	}
			
	html_input_code += " id='elem"+elementID+"' type='text'";
	html_input_code += ">"; 
	elementID++;
	
	html_code = html_code + html_input_code + html_input_code_hidden +"</form>";
	return html_code;
}

TextInputElement.changeLanguage = function(iElement) {

	var aElement = $(iElement);
	
	TextInputElement.reset(aElement);

}

TextInputElement.followingFunction = function(iEventObject){

   TextInputElement.defaultFunction(iEventObject);
   var aTarget = iEventObject.currentTarget;
   var aForm = $(aTarget).parent();
   var keyCode = iEventObject.keyCode || iEventObject.which; 
   
   if (( keyCode == 13 ) || (keyCode == 9)) {
     //console.log("Return key "+keyCode+" => handle follow");
	 //console.log(iEventObject);
	 
	 /*
	 var id = "#"+$(aTarget).attr('id');
	 if ( id.indexOf("_H")!=-1 ) {
		id = id.substring(0,id.indexOf("_H"));
		//console.log(id);
	 }
	 var aTarget = id;
	 */
	 
	 var following = aForm.data("following");
	 $(following.element).focus();
	 
   }

}

TextInputElement.validateFunction = function(iEventObject){
 
   	
   TextInputElement.defaultFunction(iEventObject);
   var aTarget = iEventObject.currentTarget;
   var aForm = $(aTarget).parent();
   var keyCode = iEventObject.keyCode || iEventObject.which; 
   
   if ( keyCode == 13 ) {
     
	    /*
		var id = "#"+$(aTarget).attr('id'); // Get the original id to retrieve data
		if ( id.indexOf("_H")!=-1 ) {
			id = id.substring(0,id.indexOf("_H"));
		}
		var aTarget = id;
		*/

		var validate = aForm.data("validate");	 
		validate();
	 
   }

}

TextInputElement.reset = function (iTarget) {

	var aTarget = iTarget;
	var aForm = $(iTarget).parent();
	$(aTarget).val("");
	// there we have to switch to the description mode
	var id = "#"+$(aTarget).attr('id');
	if ( id.indexOf("_H")!=-1 ) {
		id = id.substring(0,id.indexOf("_H"));
		//console.log(id);
	}
	aTarget = id;
	
	$(aTarget).val("");
	aForm.data("state","unmodified");
	var textcolor = aForm.data("colordescription");
	var type = aForm.data("type");
	
	if (type=="password") {
		
		$(aTarget+"_H").hide();
		$(aTarget+"_H").focus();
		$(aTarget).show();
	
	}
	
	$(aTarget).css({ "color" : textcolor});
	var translate = aForm.data("translate");
	var textValue = aForm.data("text");
	if (!(typeof translate==="undefined")) {
		textValue = International.translate( Layout.language , translate, textValue);
	}
	$(aTarget).val(textValue);
	$(aTarget).selectRange(0,0);

}

TextInputElement.defaultFunction = function(iEventObject){
	
	//console.log("Text input for element ");
	
	var aTarget = iEventObject.currentTarget;
	var keyCode = iEventObject.keyCode || iEventObject.which || iEventObject.charCode; 
	
	//console.log($(aTarget));
	var aForm = $(aTarget).parent();
	var state = aForm.data("state");
	//console.log("State "+state);
	//console.log("Shift:"+iEventObject.shiftKey);
	//console.log("Code:"+iEventObject.keyCode);
	if (!(iEventObject.shiftKey && (iEventObject.keyCode==16))) {
	
		var permitModification =  (keyCode != 13) && (keyCode != 8) && (keyCode != 5) && (keyCode != 9) ; 
		if (state=="unmodified" && permitModification) {
		
			// ++ change color
			var textcolor = aForm.data("color");
		
			var type = aForm.data("type");
			var height = aForm.data("height");
			$(aTarget).val("");
			if (type=="password") {
				// console.log("Type password  ...");
				// have to hide element and show hidden one this password symbols
				$("#"+id).hide();
				var id = $(aTarget).attr('id');
				$("#"+id+"_H").show();
				$("#"+id+"_H").focus();
				$("#"+id+"_H").css({ "color" : textcolor});
				$("#"+id+"_H").height(height);
				
				// here we switch to the hidden element, we have to forward the char
				//$("#"+id+"_H").val(String.fromCharCode(iEventObject.charCode));
				
				aTarget = "#"+id+"_H";
			}	
			aForm.data("state","modified");
			
			if (!(typeof textcolor==="undefined")) {
				$(aTarget).css({ "color" : textcolor});
			}
			
		} else {	
		
			//console.log("KeyCode:"+keyCode);
			var length = $(iEventObject.currentTarget).val().length;
			//console.log("Val:"+$(iEventObject.currentTarget).val());
			//console.log("Val length:"+length);
			if (
				(( keyCode == 8 ) && ( length==1 ))
				|| 
				(length==0)
				) {
				
				// size will be 0 or is zero
				// there we have to switch to the description mode
				TextInputElement.reset(aTarget);
				
				iEventObject.preventDefault(); // This leads in removing any update on restored description
				
			} 
		
		}
	} else {
	
		iEventObject.preventDefault()
	
	}
	
}

TextInputElement.onClickFunction = function(iClickedEvent){
	
	//console.log("Clicked input text "+iClickedEvent);
	
	var iClickedElement = iClickedEvent.currentTarget;
	var state = $(iClickedElement).parent().data("state");
	//console.log("State "+state);
	if (state=="unmodified") {
	
		//console.log("State unmodified ...");
	
		$(iClickedElement).focus();
		$(iClickedElement).selectRange(0,0);
		
		iClickedEvent.preventDefault();
	
	}
	
}

TextInputElement.prototype.setValue = function(iValue){

	var aForm = $(this.element).parent();
	var state = aForm.data("state");
	
	var type = aForm.data("type");
	var aTarget = this.element;
	var id = $(aTarget).attr('id');
	if (type=='password') {
		aTarget = "#"+id+"_H";
	}	
	
	if (iValue=="") {
		
		TextInputElement.reset(this.element);
	
	} else {
		if (state=="unmodified") {
		
			var textcolor = aForm.data("color");
			aForm.data("state","modified");
			$(aTarget).css({ "color" : textcolor});
			$(aTarget).val(iValue);
			
		} else {
		
			$(aTarget).val(iValue);
		
		}
	}
	
}

TextInputElement.prototype.getValue = function(iValue){
	var aForm = $(this.element).parent();
	var state = aForm.data("state");
	//console.log("State "+state);
	if (state=="unmodified") {
		return "";
	} else {
		var type = aForm.data("type");
		var aTarget = this.element;
		var id = $(aTarget).attr('id');
		if (type=='password') {
			aTarget = "#"+id+"_H";
		}	
		return $(aTarget).val();
	}
}

TextInputElement.prototype.afterInsert = function() {

	//console.log("after insert text input element ");
	//console.log($(this.element));

	$(this.element).click(TextInputElement.onClickFunction);
	if (this.type=="password") { $(this.element+"_H").click(TextInputElement.onClickFunction); }
	
	if (valid(this.keypressFunction)) {
	
		$(this.element).keydown(this.keypressFunction);
		if (this.type=="password") { $(this.element+"_H").keydown(TextInputElement.keypressFunction); }
	
	} else if (valid(this.following)) {
	
		$(this.element).keydown(TextInputElement.followingFunction);
		if (this.type=="password") { $(this.element+"_H").keydown(TextInputElement.followingFunction); }
	
	} else if (valid(this.validate)) {
	
		$(this.element).keydown(TextInputElement.validateFunction);
		if (this.type=="password") { $(this.element+"_H").keydown(TextInputElement.validateFunction); }
	
	} else {
	
		$(this.element).keydown(TextInputElement.defaultFunction);
		if (this.type=="password") { $(this.element+"_H").keydown(TextInputElement.defaultFunction); }
	
	}
	
	if (valid(this.sourceFunction) && (valid(this.minLength)) && (valid(this.selectFunction))) {
		
		$(this.element).autocomplete({
			source:	this.sourceFunction,
			minLength: this.minLength,
			select: this.selectFunction
		});
		
	}
	
	if (this.type=="password") {
		$(this.element+"_H").hide();
	}
	
	var aForm = $(this.element).parent();
	
	aForm.data("text",this.text);
	aForm.data("translate",this.translate);
	aForm.data("state","unmodified");
	aForm.data("type",this.type);
	aForm.data("size",this.size);
	aForm.data("padding",this.padding);
	aForm.data("following",this.following);
	aForm.data("validate",this.validate);
	aForm.data("color",this.color);
	aForm.data("colordescription",this.colorDescription);
	
	TextInputElement.resize(aForm);
	
}

// TODO Add resize for textelement

TextInputElement.resize = function(iElement,iChain,iForceResize) {

	//console.log('wrap:'+wrap);
	
	var textelement = $(iElement); // Form
	var aParent = textelement.parent(); 
	
	var size = parseInt(textelement.css("font-size"), 10);
	var padding = textelement.data("padding");
	
	var height = 2*padding+size;
	var aPadding = padding;
	
	textelement.data("height",height);
	
	// padding: 11px 0px 11px 0px;
	
	//console.log(aParent);
	//console.log(textelement);
	//console.log("Width:"+aParent.width());
	//console.log("Height:"+aParent.height());
	
	textelement.width(aParent.width()); // Always parent width
	textelement.height(height);
	
	$.each( textelement.children(".tieInput") , function(key,value) {
		
		$(value).width(aParent.width());
		$(value).height(height);
		
		if ($.browser.msie) {
			var lineHeight = aPadding+size;
			$(value).css( "line-height" , height+"px");
			$(value).css({ "padding-top" : aPadding+"px", "padding-bottom" : aPadding+"px"});
		} else {
			$(value).css({ "padding-top" : aPadding+"px", "padding-bottom" : aPadding+"px"});
		}
		
	});
		
	Element.resizeSpecialElements(iElement,iChain,iForceResize);
}

