// ######################## DEFINE ELEMENT TEXT ########################
var VerticalBarElement = function(){
	Element.call(this);
} 
VerticalBarElement.prototype = new Element();
VerticalBarElement.prototype.constructor = VerticalBarElement;

VerticalBarElement.prototype.setPosition = function (iPosition){
	this.position = iPosition;
	return this;
}

VerticalBarElement.prototype.setStyle = function (iStyle){
	this.style = iStyle;
	return this;
}

VerticalBarElement.prototype.setVStyle = function (iStyle){
	this.vstyle = iStyle;
	return this;
}

VerticalBarElement.prototype.setColor = function (iColor){
	this.color = iColor;
	return this;
}

VerticalBarElement.prototype.setWidth = function (iWidth){
	this.width = iWidth;
	return this;
}

VerticalBarElement.prototype.setHeight = function (iHeight){
	this.height = iHeight;
	return this;
}


VerticalBarElement.prototype.implement = function () {
    this.id  = elementID;
	this.element = "#elem"+elementID;
	var html_code = "<div id='elem"+elementID+"' class='verticalbarelement' style='position:absolute; top:0px; left:0px;  ";
	elementID++;

	if (valid(this.vstyle)) {
		html_code += this.vstyle;
	}

	if (!(typeof this.color==="undefined")) {
		html_code = html_code + "border-left-color: "+this.color+";";
	} else {
		html_code = html_code + "border-left-color: #000000;";
	}
	
	if (!(typeof this.style==="undefined")) {
		html_code = html_code + "border-left-style: "+this.style+";";
	} else {
		html_code = html_code + "border-left-style: solid;";
	}
	
	if (!(typeof this.width==="undefined")) {
		html_code = html_code + "border-left-width: "+this.width+";";
	} else {
		html_code = html_code + "border-left-width: 1px;";
		this.width = 1;
	}
	
	html_code = html_code + "'></div>";
	
	return html_code;
}


VerticalBarElement.prototype.afterInsert = function() {

	$(this.element).data("position",this.position);
	$(this.element).data("color",this.color);
	$(this.element).data("style",this.style);
	$(this.element).data("width",this.width);
	if (valid(this.height)) {
		$(this.element).data("height",this.height);
	} else {
		$(this.element).data("height",100);
	}
	
	VerticalBarElement.resize(this.element);
	
}

VerticalBarElement.resize = function(iElement,iChain,iForceResize) {
	
	var verticalElement = $(iElement);
	var parentElement = $(iElement).parent();
	
	var elem = verticalElement.data("parentWrap");
	var wrap = (typeof elem==="undefined"?false:elem);

	var height = verticalElement.data("height");
	
	
	if (wrap) {
	
		verticalElement.css({ top : "0px" , left : "0px" });
		verticalElement.height(height);
	
	} else { 
	
		//console.log("No wrap");
	
		var position = verticalElement.data("position");
		var width = verticalElement.data("width");
		
		var aIHeight = parentElement.innerHeight();
		var aWantedHeight = aIHeight*height/100;
		var aWantedWidth = parentElement.innerWidth();
		
		var aTop = (aIHeight-aWantedHeight)/2;
		verticalElement.height(aWantedHeight);
		
		var aLeft=0;
		if (!(typeof position==="undefined")) {
			
			if (position=="center") {
				aLeft = (aWantedWidth)/2;
			} else if (position=="right") {
				aLeft = aWantedWidth-width;
			} else {
				aLeft = width;
			}
			
		}

		verticalElement.css({ top : aTop+"px" , left : aLeft+"px" });
		
	}
	
	Element.resizeSpecialElements(iElement,iChain,iForceResize);
	
}