// ######################## DEFINE MENUBAR ELEMENT ##########################

var MenuBarElement = function(){
	Element.call(this);
	this.inner = new LinearListLayout("horizontal","wrap");
	this.inner.setAlignment("left","center");
	this.elementList = {};
}
MenuBarElement.prototype = new Element();
MenuBarElement.prototype.constructor = MenuBarElement;

MenuBarElement.prototype.setAlign = function(iAlign){
	this.inner.setAlignment(iAlign,"center");
	return this;
}

MenuBarElement.prototype.setTextColor = function(iColor){
	this.textColor = iColor;
	return this;
}

MenuBarElement.prototype.setFontSize = function(iSize){
	this.fontSize = iSize;
	return this;
}

MenuBarElement.prototype.setMouseOverColor = function(iColor){
	this.mouseOverColor = iColor;
	return this;
}

MenuBarElement.prototype.setMouseOverBkColor = function(iColor){
	this.mouseOverBkColor = iColor;
	return this;
}

MenuBarElement.prototype.setPadding = function(iPadding){
	this.padding = iPadding;
	return this;
}

MenuBarElement.prototype.setVerticalBarStyle = function(iStyle){
	this.vStyle = iStyle;
	return this;
}

MenuBarElement.prototype.setVerticalBarColor = function(iColor){
	this.vColor = iColor;
	return this;
}

// Percent
MenuBarElement.prototype.setVerticalBarHeight = function(iHeight){
	this.vHeight = iHeight;
	return this;
}

MenuBarElement.prototype.setVerticalBarWidth = function(iWidth){
	this.vWidth = iWidth; 
	return this;
}

MenuBarElement.prototype.implement = function () {

	var html_code = this.inner.implement();
	
	// hack to handle correctly sizing
	this.id = this.inner.id;
	this.element = this.inner.element;
	
	//console.log("MenuBarElement");
	//console.log(this.id);
	//console.log(this.element);
	
	return html_code;
	
}

MenuBarElement.prototype.pushElements = function(iElements,iTranslates){


	for (var i=0; i<iElements.length; i++) {
	
		var translate;
		if (valid(iTranslates)) {
			translate = iTranslates[i];
		}
		if (i==0) {
			this.pushElement(iElements[i],translate);
		} else {
			this.setVerticalBar();
			this.pushElement(iElements[i],translate);
		}
	
	}

}

MenuBarElement.prototype.pushElement = function(iText,iTranslate){

	var aTextElement = new TextElement(iText);
	
	if (valid(this.textColor)) {
		aTextElement.setColor(this.textColor);
	}
	if (valid(this.fontSize)) {
		aTextElement.setFontSize(this.fontSize);
	}
	if (valid(this.mouseOverColor)) {
		aTextElement.setMouseOverColor(this.mouseOverColor);
	}
	if (valid(this.mouseOverBkColor)) {
		aTextElement.setMouseOverBkColor(this.mouseOverBkColor);
	}
	if (valid(this.padding)) {
		aTextElement.setStyle("padding:"+this.padding+";");
	}
	if (valid(iTranslate)) {
		aTextElement.translate(iTranslate);
	}
	
	this.inner.pushElement(aTextElement);
	
	this.elementList[iText] = aTextElement; // This is to keep reference on menu bar elements
	
}

MenuBarElement.prototype.setVerticalBar = function(){

	var aVerticalBar = new VerticalBarElement();
	
	if (valid(this.vStyle)) {
		aVerticalBar.setStyle(this.vStyle);
	}
	
	if (valid(this.vColor)) {
		aVerticalBar.setColor(this.vColor);
	}
	
	if (valid(this.vWidth)) {
		aVerticalBar.setWidth(this.vWidth);
	}
	
	if (valid(this.vHeight)) {
		aVerticalBar.setHeight(this.vHeight);
	}
	
	this.inner.pushElement(aVerticalBar);

}

MenuBarElement.prototype.getInnerElements = function () {
	return this.inner.getInnerElements();
}

MenuBarElement.prototype.afterInsert = function (){
	
	this.inner.afterInsert();
	LinearListLayout.resize($(this.inner.element));
	
}
