// ######################## DEFINE GRIDLAYOUT ##########################

var GridLayout = function(iWidth,iHeight){
	Layout.call(this);
	this.width = iWidth;
	this.height = iHeight;
	this.columnsProperties = new Array(iWidth);
	this.container = new Array(iWidth);
	for (var i = 0; i < this.width; i++) {
		this.container[i] = new Array(this.height);
	}
}
GridLayout.prototype = new Layout();
GridLayout.prototype.constructor = GridLayout;

GridLayout.prototype.implement = function () {
	
	this.id  = elementID;
	this.element = "#elem"+elementID;
	elementID++;
	
	var html_code = "";
	if (this.prop!=null){
		
		html_code="<div id='elem"+this.id+"' class='gridlayout' "; // identify class layout to handle resize
		
		//if (!(typeof this.prop.id==="undefined")) {html_code = html_code + " id='"+this.prop.id+"' ";}
		if (!(typeof this.prop.classtype==="undefined")) {html_code = html_code + " class='"+this.prop.classtype+"' ";}
		
		//Style
		html_code = html_code + " style='";
		if (!(typeof  this.prop.fullscreen==="undefined")) {
			if ( this.prop.fullscreen) {
				html_code = html_code + "position:fixed; top:0px; left:0px; margin: 0px; padding: 0px;";
			} else {
				html_code = html_code + "height:100%; margin: 0px; padding: 0px;";
			}
		} else {
			html_code = html_code + "height:100%; margin: 0px; padding: 0px;";
		}
		if (!(typeof this.prop.style==="undefined")) {
			html_code = html_code +this.prop.style;
		} 
		html_code = html_code +"' ";
		
	
		html_code=html_code+" >";
		
	} else {	
		html_code="<div id='elem"+this.id+"' class='gridlayout' >"; // identify class layout to handle resize
	}
	
	
	for (var i = 0; i < this.width; i++) {
	
		var aBlockWidth = 0;
	
		if (!(typeof this.columnsProperties[i] === "undefined")) { 
	
			if ((this.columnsProperties[i].vertical=="top") || (this.columnsProperties[i].vertical=="bottom")) {
				html_code = html_code + "<div class='gLB' style='width:"+aBlockWidth+"px; top: 0px; height: 100%'>";
			} else if (this.columnsProperties[i].vertical=="center") {
				html_code = html_code + "<div class='gLB' style='width:"+aBlockWidth+"px; top: 0px; height: 100%' >";
			} else {
				html_code = html_code + "<div class='gLB' style='width:"+aBlockWidth+"px; top: 0px; height: 100%; ' >";
			}
		
		} else {
			html_code = html_code + "<div class='gLB' style='width:"+aBlockWidth+"px; top: 0px; height: 100%; ' >";
		}
		
		for (var j = 0; j < this.height; j++) {
		
			if (typeof this.container[i][j] === "undefined"){
				// Fill nothing
			} else {
				//console.log("TypeOf Elem:"+(this.container[i][j].element instanceof ContainerElement));
				
				this.container[i][j].element = this.checkWrapping(this.container[i][j].element);
										
				html_code = html_code + "<div class='gLC' style='left:0px; top:0px;"+
										(!(typeof this.container[i][j].style==="undefined")?this.container[i][j].style:"")+"'>"+this.container[i][j].element.implement()+"</div>";
			}
		}
		
		html_code = html_code + "</div>";
		
		/*
		if (!(typeof this.columnsProperties[i] === "undefined")) { 
		
			if ((this.columnsProperties[i].vertical=="top") || (this.columnsProperties[i].vertical=="bottom")) {
				html_code = html_code + "</div>";
			} else if (this.columnsProperties[i].vertical=="center") {
				html_code = html_code + "</div>";
			} else {
				html_code = html_code + "</div>";
			}
		
		} else {
		
			html_code = html_code + "</div>";
		
		}
		*/
		
	}
	html_code = html_code + "</div>";
	
	return html_code;
	
}


GridLayout.prototype.afterInsert = function(){

	//console.log("GridLayout after insert for element :"+this.element);
	// Add prop to the element
	var aElement = $(this.element);
	aElement.data('prop', this.prop);
	aElement.data('numberOfColumns', this.width);
	aElement.data('columnProperties', this.columnsProperties);
	
	for (var i = 0; i < this.width; i++) {
	
		for (var j = 0; j < this.height; j++) {
		
			if (!(typeof this.container[i][j] === "undefined")){
			
				var id;
				if (this.container[i][j].element instanceof MapperElement) {
					id = "#"+this.container[i][j].element.id; 
				} else {
					id = "#elem"+this.container[i][j].element.id; // Setup y position to the cell element
				}
				$(id).closest(".gLC").data('y',j); // Setup cell position
				
				if (valid(this.prop)) {
				
					if (valid(this.prop.wrap)) {
						$(this.container[i][j].element.element).data('parentWrap',this.prop.wrap);
					}
				
				}
				
				this.container[i][j].element.afterInsert();
			}
			
		}
		
	}

	// TODO inversion on resize handling when wrapping mode
	//handleResize(); // adding a layout can modify all layout sizes
					  // i.e adding a scrollbar
	
	GridLayout.resize(this.element);
	
}

GridLayout.truncate = function(n) {
  return Math[n > 0 ? "floor" : "ceil"](n);
}

GridLayout.checkNeededResize = function(iLayout,iForceResize) {

	var aLayout = $(iLayout);
	var elem = aLayout.data("parentW");
	var pParentWidth = (valid(elem)?elem:0);
	elem = aLayout.data("parentH");
	var pParentHeight = (valid(elem)?elem:0);
	
	var parentWidth = aLayout.parent().width();
	var parentHeight = aLayout.parent().height();

	//console.log("parentW:"+parentWidth+" pPW:"+pParentWidth);
	//console.log("parentH:"+parentHeight+" pPW:"+pParentHeight);

	var result = true;
	if ((parentWidth == pParentWidth) && (parentHeight==pParentHeight)) {
		result = false;
	} 

	//console.log("Result:"+result);

	aLayout.data("parentW",parentWidth);
	aLayout.data("parentH",parentHeight);

	return result || iForceResize ;

}

GridLayout.resize = function(iLayout,iChain,iForceResize){

	// iLayout is an id
	var aLayout = $(iLayout);

	var prop = aLayout.data('prop');
	var width = aLayout.data('numberOfColumns');
	var columnProperties = aLayout.data('columnProperties');
	
	var parentWrap = (valid(aLayout.data('parentWrap'))?aLayout.data('parentWrap')==true:false);
	
	var blocks = aLayout.children(".gLB");
	
	// defined booleans
	var propDefined = (!(typeof prop==="undefined")) && (prop!=null);
	var fixedDefined = (propDefined?!(typeof prop.fixed==="undefined"):false);
	var percentDefined = (propDefined?!(typeof prop.percent==="undefined"):false);
	var wrapDefined = (propDefined?!(typeof prop.wrap==="undefined"):false);
	
	var aElementWidth = aLayout.parent().width();
	var maxHeight = 0;
	
	
	var wrap = false;
	var fullscreen = false;
	if (propDefined) {
	
		// Wrap elements to fixed sizes
		if (wrapDefined){
		
			if (prop.wrap==true) {
				wrap = true;
			}
			
			
			if (wrap) {
			
				prop.fixed = [];
				fixedDefined = true;
			
				for (var j=0; j<blocks.length; j++) {
				
					var maxWidth = 0;
					var child = $(blocks[j]).children(".gLC");
					for (var i=0; i<child.length; i++) {
					
						var value = $(child[i]);
						handleDependentResize(value,iChain,iForceResize);
						var oW = value.children().outerWidth();
						if (oW>maxWidth) {
							maxWidth = oW;
						}
					
					}
					prop.fixed[j] = maxWidth;
					
				
				}

			} 
						
		} 
	
		if (valid(prop.fullscreen)){
		
			if (prop.fullscreen) { // this will probably request a new size calculation
				
				//console.log("Fullscreen mode");
				fullscreen = true;
				
				var aElementWidth = $(window).width()-2;
				var aElementHeight = $(window).height()-2; // TODO replace by border size
				var aCWidth= aLayout.width();
				var aCHeight = aLayout.height();
				
				// Check min size of fixed size for width
				if (fixedDefined) {
					//var sumFixed = prop.fixed.reduce(function(a, b) { return a + b; }, 0); // to add at the end of IE8 :-)
					var sumFixed = 0;
					for (var i=0; i<prop.fixed.length;i++){
						sumFixed+=prop.fixed[i];
					}
					if (sumFixed>aElementWidth) {
						aElementWidth = sumFixed;
					}
				}
				
				aMaxHeight = aElementHeight;
				
			}
		
		
		}
		
		if ((!wrap) && (!fullscreen)) {
		
			if (!GridLayout.checkNeededResize(aLayout,iForceResize)) {
				//console.log("Resize not needed")
				//console.log(iLayout);	
				return;
			}
			
		}
		
		//console.log("Resize needed")
		//console.log(iLayout);	
		
	}
	
	// Comput the max height of each blocks
	var columnLead = 0;
	var nPercent = 0;
	var nWrap = 0;
	var nDefined = 0;
	//console.log("Compute block height");
	for (var j=0; j<blocks.length; j++) {
	
		var cprop;
		if (valid(columnProperties)) { cprop = columnProperties[j];}
		var cpropdefined = false;
		var fixed = false;
		var percent = false;
		var hWrapDefined = false;
		if (!(typeof cprop==="undefined")) {
			cpropdefined = true;
			fixed = valid( cprop.fixed );
			percent	= valid( cprop.percent );
			hWrapDefined = valid( cprop.wrap );
		}
	
		if (cpropdefined){
		    nDefined++;
			if (percent) {
			   nPercent++;
			}
			if (hWrapDefined) {
			   nWrap++;
			}
		}
	
		var block = $(blocks[j]);
		var child = block.children(".gLC");
	
		// Wrap Height
		if (hWrapDefined){
		
			if (cprop.wrap==true) {
		
				//console.log("Column ("+j+") start wrapping ");
		
				cprop.fixed = [];
			
				for (var i=0; i<child.length; i++) {
					var value = $(child[i]);
					var y = value.data('y'); // get height position of the cell
					cprop.fixed[y] = value.children().outerHeight(); // force cell height
				}

			}
		
		}
	
		var size = 0; // Define height of each cell
		for (var i=0; i<child.length; i++) {
			
			var aValue = $(child[i]);
			var y = aValue.data('y');
			// Column properties
			if (cpropdefined && fixed) {
				if (valid(cprop.fixed[y])) {
					aValue.height(cprop.fixed[y]);
					size += cprop.fixed[y];
				}
			} 
			
			
		}
		
		if (size>maxHeight) {
			maxHeight = size;
			columnLead = j;
		}
		
	}
	
	//console.log("After fixed + wrap Max Height:"+maxHeight);
	
	var aWantedDefine = $(iLayout).parent().height();
	if (propDefined) {
		if (valid(prop.fullscreen)){
			if (prop.fullscreen) {
				aWantedDefine = $(window).height();
			}
		} 
	}
	
	// In Wrap mode we have to keep max height
	if ((nWrap!=nDefined) && (!parentWrap)) {
		maxHeight=aWantedDefine;
	}	
	
	//console.log("After defining fixed height + wrap wanted Height:"+maxHeight);
	
	// Special case for fixed height definition
	for (var j=0; j<blocks.length; j++) {
	
		var block = $(blocks[j]);
		var cprop;
		if (valid(columnProperties)) { cprop = columnProperties[j];}
		var cpropdefined = false;
		var fixed = false;
		if (valid(cprop)) {
			cpropdefined = true;
			fixed = valid(cprop.fixed);
		}
	
		if (cpropdefined && fixed) { // If column fixed
	
			var child = block.children(".gLC");
			var numberNotDefined = 0;
			var cumulHeight = 0;
			for (var i=0; i<child.length;i++) {
			
				var aValue = $(child[i]);
				var y = aValue.data('y');
				// Column properties			
				if (valid(cprop.fixed[y])) {
					if (cprop.fixed[y]==0) {
						numberNotDefined++;
					} else {
						cumulHeight+=aValue.height();
					}
				}
				 
			}
		
			var aPosY = 0;
			var aRemainder = (maxHeight-cumulHeight);
			if (aRemainder<0) {
				aRemainder = 0;
			}
			if (cpropdefined) {
				if ((numberNotDefined==0) && (cprop.vertical=='center')){
					aPosY = aRemainder/2;
				}
			}
	
			for (var i=0; i<child.length;i++) {
				var aValue =  $(child[i]);
				var y = aValue.data('y');
				
				// Column properties
				if (valid(cprop.fixed[y])) {
					
					if (cprop.fixed[y]==0) {
						aValue.height(aRemainder/numberNotDefined);
					}
						
					aValue.css({ top: aPosY });
					aPosY = aPosY + aValue.height(); // Set top position
				
				} 
			}
		
		}
		
	}
	
	// Try to handle undefined size for column
	// By default we want to fill 100% of the parent
	// so undefined size for column will complete the
	// parent size.
	var numberUndefined = 0;
	var sizeDefined = 0;
	// TODO record precalculated
	if (fixedDefined || percentDefined) {
		for (var i=0; i<blocks.length; i++) {
			
				if (percentDefined) {
				
					if (!(typeof prop.percent[i]==="undefined")) { // Percentage definition
						if (prop.percent[i]!=0) {
							sizeDefined += GridLayout.truncate((prop.percent[i]*aElementWidth)/100);
						} else {
							numberUndefined++;
						}
					} else {
						numberUndefined++;
					}
				
				} else if (fixedDefined) {
				
					if (!(typeof prop.fixed[i]==="undefined")) { // Fixed definition 
						if (prop.fixed[i]!=0) {
							sizeDefined += prop.fixed[i];
						} else {
							numberUndefined++;
						}
					} else {
						numberUndefined++
					}
				
				} 
				
		}
	}
	
	var remainder = ((aElementWidth-sizeDefined)/numberUndefined);
	if (remainder<0) { remainder = 0; };
	
	// Resize blocks 
	var relativePosition = 0;
	var maxWidth = 0;
	var realMaxHeight = 0;
	for (var i=0; i<blocks.length; i++) {
	
		var aBlockWidth = 0;
		if (percentDefined) {
		
			if (!(typeof prop.percent[i]==="undefined")) { // Percentage definition
				if ( prop.percent[i] != 0 ) {
					aBlockWidth = GridLayout.truncate((prop.percent[i]*aElementWidth)/100);
				} else {
					aBlockWidth = remainder;
				}
			} else {
				aBlockWidth = remainder;
			}
		
		} else if (fixedDefined) {
		
			if (!(typeof prop.fixed[i]==="undefined")) { // Fixed definition 
				if (prop.fixed[i] !=0 ) { 
					aBlockWidth = prop.fixed[i];
				} else {
					aBlockWidth = remainder;
				}
			} else {
				aBlockWidth = remainder;
			}
		
		} else { // If nothing divide the size in equal parts
			aBlockWidth = aElementWidth/width;
		}
		
		// Block width compute.
		var block = $(blocks[i]);
		var aCBlockWidth = block.width();
		block.width(aBlockWidth);
		block.css( { left: relativePosition+"px"});
		relativePosition = relativePosition+aBlockWidth;
		maxWidth = maxWidth + aBlockWidth; // = relative position
		
		// ############################## COMPUT PERCENT HEIGHT ###################################
		// Comput Height of elements for percent definition
		var cprop;
		if (valid(columnProperties)) { cprop = columnProperties[i];}
		var cpropdefined = false;
		var fixed = false;
		var percent = false;
		if (valid(cprop)) {
			cpropdefined = true;
			fixed = valid(cprop.fixed);
			percent	= valid(cprop.percent);
		}
	
		// Pre build values;
		var heightAcc = 0;
		var miss = 0;
		var cells = block.children(".gLC");
		for (var j=0;j<cells.length;j++) {
		
			var aValue = $(cells[j]);
			var y = aValue.data('y');
			
			// Column properties
			if (cpropdefined && percent) {
				if (valid(cprop.percent[y])) {
					var val = GridLayout.truncate((cprop.percent[y]*maxHeight)/100);
					//console.log("Defined val "+val);
					if (cprop.percent[y]!=0) {
						aValue.height(val);
						aValue.width(aBlockWidth);
						heightAcc+=val;
					} else {
						miss++;
					}
					
				} 
			} else {
			
				heightAcc+=aValue.height();
			
			}
	
		}
		var heightRemainder = (maxHeight-heightAcc);
		if (miss!=0) { heightRemainder = heightRemainder/miss; }
		if (heightRemainder<0) {heightRemainder=0;}
	
		// This is needed to center cells in the layout (top, center)
		// For percent column definition, define center only if no cells 
		// defined with 0 height i.e. no automatic resize
		// If miss == 0 we have to center if needed
		
		var aPosY = 0;
		if (cpropdefined) {
			if ((miss==0) && (cprop.vertical=='center')){
				aPosY = heightRemainder/2;
			}
		}
	
		
		for (var j=0;j<cells.length;j++) {
		
			var aValue = $(cells[j]);
		
			var y = aValue.data('y');
			// Column properties
			if (cpropdefined && percent) {
				if (!(typeof cprop.percent[y]==="undefined")) { 
				
					if (cprop.percent[y]==0) { 
						aValue.height(heightRemainder);
						aValue.width(aBlockWidth);
					} 

					//console.log("PosY:"+aPosY);
					aValue.css({ top: aPosY });
					aPosY = aPosY + aValue.height(); // Set top position
					aValue.width(aBlockWidth); // Size block with
					
				}
				
			} else if (cpropdefined && fixed) {
			
				aValue.width(aBlockWidth); 
				aPosY = aPosY + aValue.height();
			
			} else {
			
				aValue.css({ top: aPosY }); // To Center
				aPosY = aPosY + aValue.height(); // Set top position
				aValue.width(aBlockWidth); 
			
			}
			
		}
		// aPosY contains the real height // cumulative height
		
		// end of height definition
		// ############################## END COMPUT PERCENT HEIGHT ################################
		
		if (propDefined) {
			if (!prop.fullscreen) {	
				//
				block.height(maxHeight);
				if (maxHeight>realMaxHeight) {
					realMaxHeight = maxHeight;
				}

			} else { // If fullscreen, if size of blocks > document.height()
					 // i.e fixed case or may be wrapped mode ?
					 // this permit scroll bar when override != hidden	
			
				if (aPosY!=0) {
					block.height(aPosY);
					if (aPosY>realMaxHeight) {
						realMaxHeight = aPosY;
					}
				} else {
					block.height(maxHeight);
					if (maxHeight>realMaxHeight) {
						realMaxHeight = maxHeight;
					}
				}
				
			}
		} else {
			block.height(maxHeight);
			if (maxHeight>realMaxHeight) {
				realMaxHeight = maxHeight;
			}
		}

		//console.log("remainder:"+heightRemainder);
		//console.log("defined aPosY:"+aPosY);	
		//console.log("defined MaxHeight:"+maxHeight);
		//console.log("realMaxHeight:"+realMaxHeight);
	
	}
	
	if (propDefined) {
		if (wrapDefined) {
			aLayout.width(maxWidth);
			aLayout.height(maxHeight);
		}
		if (parentWrap) {
			aLayout.width(maxWidth);
			aLayout.height(maxHeight);
		}
		if (prop.fullscreen) {
			aLayout.height(maxHeight);
			aLayout.width(maxWidth);
			if (realMaxHeight>maxHeight) {
				aLayout.css("overflow-y","scroll");
				aLayout.css("overflow-x","hidden");
			} else {
				aLayout.css("overflow-y","hidden");
				aLayout.css("overflow-x","hidden");
			}
		}
	}
	
	if (!wrapDefined) {
		handleDependentResize(aLayout,iChain,iForceResize);
	} else {
		if (prop.wrap==false) {
			handleDependentResize(aLayout,iChain,iForceResize);
		}
	}
	
	Element.resizeSpecialElements(iLayout,iChain,iForceResize);
}

GridLayout.prototype.add = function (iX,iY,iElement) {
	
	var defined = !(typeof this.container[iX][iY]==="undefined");
	if (defined) { 
		this.container[iX][iY] = {
			id : elementID,
			classtype : this.container[iX][iY].classtype,
			style : this.container[iX][iY].style,	
			element : iElement
		};
	} else {
		this.container[iX][iY] = {
			id : elementID,
			element : iElement
		};
	}
	elementID++;
	return this;
	
}

GridLayout.prototype.getInnerElements = function () {

	var elements = [];

	for (var i = 0; i < this.width; i++) {
	
		for (var j = 0; j < this.height; j++) {
		
			if (!(typeof this.container[i][j] === "undefined")){
			
				elements.push(this.container[i][j].element);
			
			}
			
		}
		
	}

	return elements;
}

GridLayout.prototype.addColumnProperties = function (iX, iProperties){
	
	this.columnsProperties[iX] = iProperties;
	return this;
	
}

GridLayout.prototype.addProperties = function (iX,iY,iProperties) {

	var defined = !(typeof this.container[iX][iY]==="undefined");
	if (defined) {
		this.container[iX][iY] = {
			id : elementID,
			classtype : iProperties.classtype,
			style : iProperties.style,	
			element : this.container[iX][iY].element
		};
	} else {
		this.container[iX][iY] = {
			id : elementID,
			classtype : iProperties.classtype,
			style : iProperties.style
		};
	}
	elementID++;
	return this;
}
