// ######################## DEFINE LINEARLISTLAYOUT ##########################

var LinearListLayout = function(iOrientation,iMode){
	Layout.call(this);
	this.orientation = iOrientation;
	this.mode = iMode;
	this.innerlayout = null;
	this.elementList = [];
	this.elementSize = [];
}
LinearListLayout.prototype = new Layout();
LinearListLayout.prototype.constructor = LinearListLayout;

LinearListLayout.prototype.implement = function () {

	var html_code = "<div id='elem"+elementID+"' class='linearlistlayout'>";
	this.id = elementID;
	this.element = "#elem"+this.id;
	elementID++;
	
	if (this.elementList.length>0) {
	
		if (this.orientation=="horizontal") {
			
			var halignDef = (!(typeof this.halign==="undefined")?this.halign:"left");
			var gridSize = (halignDef=="center"?this.elementList.length+2:(halignDef=="right"?this.elementList.length+1:this.elementList.length));
			
			var shift = 0;
			var aElementSize = [];
			if ((halignDef=="center") || (halignDef=="right"))  {
				shift = 1;
				aElementSize.push(0);
			}
			aElementSize = aElementSize.concat(this.elementSize);
			if (halignDef=="center")  {
				aElementSize.push(0);
			}
			//console.log("Given element size:"+this.elementSize);
			//console.log("Element Size Array:"+aElementSize);
			//console.log("Grid Size:"+gridSize);
			//console.log("Mode:"+this.mode);
			
			this.innerlayout = new GridLayout(gridSize,1);
			if (this.mode=="wrap") { // Force also column properties to wrap
				this.innerlayout.setProperties({ // TODO define fullscreen value
					style:' width:100%;',
					wrap: true
				});
			} else {
				this.innerlayout.setProperties({ // TODO define fullscreen value
					style:' width:100%;',
					fixed: aElementSize
				});
				//console.log("ElementSizes:");
				//console.log(aElementSize);
			}
			
			var valignDef = (!(typeof this.valign==="undefined")?this.valign:"top");
			
			for (var i=0; i<this.elementList.length; i++){
				//console.log("Add column "+(i+shift));
				this.innerlayout.add(i+shift,0,this.elementList[i]);
				if (this.mode=="wrap") { // this check wrapping mode
					this.innerlayout.addColumnProperties(i+shift,{vertical: valignDef,wrap:true}); 
				} else {
					this.innerlayout.addColumnProperties(i+shift,{vertical: valignDef,percent:[100]}); 
				}
			}
			
			//console.log(this.innerlayout);
			
			html_code += this.innerlayout.implement();
			
		} else if (this.orientation=="vertical") {
		
			this.innerlayout = new GridLayout(1,this.elementList.length);
			if (this.mode=="wrap") { // Force also column properties to wrap
				this.innerlayout.setProperties({ // TODO define fullscreen value
					style:' width:100%;',
					wrap: true
				});
			} else {
				this.innerlayout.setProperties({ // TODO define fullscreen value
					style:' width:100%;',
					percent: [100]
				});
			}
			
			//var alignDef = (!(typeof this.align==="undefined")?this.align:"top");
			
			for (var i=0; i<this.elementList.length; i++){
				//console.log("Add line "+i);
				this.innerlayout.add(0,i,this.elementList[i]);
				if (this.mode=="wrap") { // this check wrapping mode
					this.innerlayout.addColumnProperties(i,{vertical: "top",wrap:true}); 
				} else {
					this.innerlayout.addColumnProperties(i,{vertical: "top",fixed:this.elementSize}); 
				} 
			}
			
			//console.log(this.innerlayout);
			
			html_code += this.innerlayout.implement();
		
		}
		
	} else {
		this.innerlayout = new GridLayout(0,0);
	}
	
	html_code += "</div>";
	
	return html_code;
	
}

LinearListLayout.prototype.refresh = function() {

	var implemented=(!(typeof this.implemented==="undefined")?true:false);
	if (implemented) {
		//console.log("Insert for LinearLayout:"+this.element);
		//console.log($(this.element));
		var aElem = $(this.element).parent();
		//aElem.empty();
		var html_code = this.implement();
		//console.log(html_code);
		aElem.html(html_code);
		
		forceResize = true;
		this.afterInsert();
		forceResize = false;
		
	}

}

LinearListLayout.prototype.addElement = function(iElement,iSize){

	this.elementList.push(iElement);
	this.elementSize.push(iSize);
	
}

LinearListLayout.prototype.removeElementByTag = function(iTag) {

	var pos = -1;
	for (var i=0; i<this.elementList.length; i++) {
		var aElement = this.elementList[i];
		if (valid(aElement.tag)) {
			if (aElement.tag==iTag) {
				pos=i;
				break;
			}
		}
	}

	if (pos!=-1) {
		this.elementList.splice(pos,1);
		this.elementSize.splice(pos,1); 
		this.refresh();
	}

}

LinearListLayout.prototype.getInnerElements = function () {
	return this.elementList;
}

LinearListLayout.prototype.pushElement = function(iElement,iSize){

	this.addElement(iElement,iSize);
	this.refresh();
	
}

LinearListLayout.prototype.dropAll = function(){
	
	this.elementList = [];
	this.elementSize = [];
	
}

LinearListLayout.prototype.clear = function(){
	
	this.dropAll();
	this.refresh();
	
}

LinearListLayout.prototype.setAlignment = function (iHAlign,iVAlign){
	this.valign=iVAlign;
	this.halign=iHAlign;
	return this;
}

LinearListLayout.prototype.afterInsert = function (){
	//console.log("LinearListLayout after insert");
	//console.log(this.element);
	//this.innerlayout.element = this.element;
	
	this.innerlayout.afterInsert();
	
	var aElement = $(this.element);
	
	aElement.data("mode",this.mode);
	aElement.data("halign",this.halign);
	aElement.data("valign",this.valign);
	
	LinearListLayout.resize(aElement,"",0);
	
	this.implemented = true;
	
}

LinearListLayout.resize = function(iElement,iChain,iForceResize){
	
	var aElement = $(iElement);
	var mode = aElement.data("mode");
	if (mode=='wrap') {
		//console.log("LinearListLayout wrap");
		
		var parent =  aElement.parent();
		aElement.width( parent.width() );
		aElement.height( parent.height() );
		
		handleDependentResize(aElement,iChain,iForceResize);
		
		var child = aElement.children(".gridlayout");
		aElement.width( child.outerWidth() );
		aElement.height( child.outerHeight() );
	
	} else {
	
		var elem = aElement.data("parentWrap");
		var pwrap = false;
		if (valid(elem)) {
			pwrap = elem;
		}
		
		if (!pwrap) {
			var parent =  aElement.parent();
			aElement.width( parent.width() );
			aElement.height( parent.height() );
		}
		
		handleDependentResize(aElement,iChain,iForceResize);
	
		if (pwrap) {
		
			var child = aElement.children(".gridlayout");
		
		
		}
		
	}
	
	Element.resizeSpecialElements(iElement,iChain,iForceResize);
}
